/** Double-include prevention */
#if defined _togservervalidation_included_
  #endinput
#endif
#define _togservervalidation_included_

/*
//#define VALIDATION_IP ""
//#define VALIDATION_TIME 
//#define VALIDATION_HOSTNAME ""

#if defined(VALIDATION_TIME) || defined(VALIDATION_IP) || defined(VALIDATION_HOSTNAME)
	#include <togservervalidation>
#endif

#if defined(VALIDATION_TIME) || defined(VALIDATION_IP) || defined(VALIDATION_HOSTNAME)
	ValidateServer();
#endif

#if defined VALIDATION_TIME
	ValidateServer();
#elseif defined VALIDATION_IP
	ValidateServer();
#elseif defined VALIDATION_HOSTNAME
	ValidateServer();
#endif
*/

stock ValidateServer()
{
	char sPluginName[128];
	GetPluginFilename(INVALID_HANDLE, sPluginName, sizeof(sPluginName));
	
#if defined VALIDATION_TIME
	char sExpireTime[128];
	FormatTime(sExpireTime, sizeof(sExpireTime), "%c", VALIDATION_TIME);
	if(GetTime() > VALIDATION_TIME)
	{
		LogError("Server validation expired! Validation expiration date (%s) has been passed. Please contact plugin author (Alliedmodders: That One Guy) for a valid copy of the plugin.", sExpireTime);
		ServerCommand("sm plugins unload %s", sPluginName);
	}
	else
	{
		LogMessage("Server validation has not yet expired for plugin %s. Validation will expire: %s", sPluginName, sExpireTime);
	}
#endif
	
#if defined VALIDATION_IP
	ValidateServerIP();
	CreateTimer(5.0, TimerCB_ValidateServerIP, _, TIMER_FLAG_NO_MAPCHANGE);
	CreateTimer(180.0, TimerCB_ValidateServerIP, _, TIMER_FLAG_NO_MAPCHANGE);
#endif
	
#if defined VALIDATION_HOSTNAME
	CreateTimer(10.0, TimerCB_ValidateHostName, _, TIMER_FLAG_NO_MAPCHANGE);
	CreateTimer(180.0, TimerCB_ValidateHostName, _, TIMER_FLAG_NO_MAPCHANGE|TIMER_REPEAT);
#endif
}

public Action TimerCB_ValidateHostName(Handle hTimer)
{
#if defined VALIDATION_HOSTNAME
	ValidateHostName();
#endif
	return Plugin_Continue;
}

public Action TimerCB_ValidateServerIP(Handle hTimer)
{
#if defined VALIDATION_IP
	ValidateServerIP();
#endif
	return Plugin_Continue;
}

stock void ValidateHostName()
{
	Handle hHostName = INVALID_HANDLE;
	hHostName = FindConVar("hostname");
	char sHostName[128];
	GetConVarString(hHostName, sHostName, sizeof(sHostName));
	
	if(StrContains(sHostName, VALIDATION_HOSTNAME, false) == -1)
	{
		LogError("Server hostname validation failed! Please contact plugin author (Alliedmodders: That One Guy) for a valid copy of the plugin. Hostname: %s", sHostName);
		char sPluginName[128];
		GetPluginFilename(INVALID_HANDLE, sPluginName, sizeof(sPluginName));
		ServerCommand("sm plugins unload %s", sPluginName);
	}
}

stock void ValidateServerIP()
{
	char sPluginName[128];
	GetPluginFilename(INVALID_HANDLE, sPluginName, sizeof(sPluginName));
	
	char sServerIP[30];
	int aArray[4];
	int iLongIP = GetConVarInt(FindConVar("hostip"));
	
	aArray[0] = (iLongIP >> 24) & 0x000000FF;
	aArray[1] = (iLongIP >> 16) & 0x000000FF;
	aArray[2] = (iLongIP >> 8) & 0x000000FF;
	aArray[3] = iLongIP & 0x000000FF;
	Format(sServerIP, sizeof(sServerIP), "%d.%d.%d.%d", aArray[0], aArray[1], aArray[2], aArray[3]);
	
	if(StrContains(VALIDATION_IP, ";", false) != -1)
	{
		bool bFound = false;
		int c = 0, iCount = 0;
		char sValidationIP[1000];
		strcopy(sValidationIP, sizeof(sValidationIP), VALIDATION_IP);
		
		while(sValidationIP[c] != '\0')
		{
			if(sValidationIP[c++] == ';')
			{
				iCount++;
			}
		}
		iCount++; //add one more for IP after last comma
		
		char[][] a_sTempArray = new char[iCount][32];
		ExplodeString(sValidationIP, ";", a_sTempArray, iCount, 32);
		for(new i = 0; i < iCount; i++)
		{
			if(StrContains(sServerIP, a_sTempArray[i], false) != -1)
			{
				LogMessage("Server validated with IP: %s", a_sTempArray[i]);
				bFound = true;
				break;
			}
		}
		if(!bFound)
		{
			LogError("Server IP validation failed! Server IP (%s) does not match any of the validation IP's. Please contact plugin author (Alliedmodders: That One Guy) for a valid copy of the plugin.", sServerIP);
			ServerCommand("sm plugins unload %s", sPluginName);
		}
	}
	else
	{
		if(StrContains(sServerIP, VALIDATION_IP, false) != -1)
		{
			LogMessage("Server validated with IP: %s", sServerIP);
		}
		else
		{
			LogError("Server IP validation failed! Server IP (%s) does not match validation IP (%s). Please contact plugin author (Alliedmodders: That One Guy) for a valid copy of the plugin.", sServerIP, VALIDATION_IP);
			ServerCommand("sm plugins unload %s", sPluginName);
		}
	}
}