#pragma semicolon 1
#pragma dynamic 131072 //increase stack space to from 4 kB to 131072 cells (or 512KB, a cell is 4 bytes).

//PLUGIN SERVER VALIDATION!
//#define VALIDATION_IP ""

#define PLUGIN_VERSION 			"4.3.3"
#define TAG 					" \x04[TOG RTD] "
#define SOUND_BLIP 				"buttons/blip1.wav"
#define CSGO_RED 				" \x07"
#define CSS_RED 				"\x07FF0000"
#define SPECMODE_NONE 			0
#define SPECMODE_FIRSTPERSON 	4
#define SPECMODE_3RDPERSON 		5
#define SPECMODE_FREELOOK		6
#define VISUALS_CHECK_FREQ 		1.0
#define FFADE_STAYOUT 			0x0008
#define FFADE_PURGE 			0x0010

#include <sourcemod>
#include <sdktools>
#include <sdkhooks>
#include <cstrike>
#include <clientprefs>
#include <dbi>
#include <emitsoundany>
#include <dynamic>
#include <autoexecconfig>	//https://github.com/Impact123/AutoExecConfig  or  http://www.togcoding.com/showthread.php?p=1862459
#if defined(VALIDATION_TIME) || defined(VALIDATION_IP) || defined(VALIDATION_HOSTNAME)
	#include <togservervalidation>
#endif

#undef REQUIRE_PLUGIN
#include <store>
#pragma newdecls required

//plugin cvars
ConVar g_cAdminFlag = null;
char g_sAdminFlags[60];
ConVar g_cAccessFlags = null;
char g_sAccessFlags[60];
ConVar g_cReviveBlockRTDs = null;
ConVar g_cTeamsAllowed = null;
ConVar g_cGhostCount = null;
ConVar g_cFuelAmmount = null;
ConVar g_cJetPackVel = null;
ConVar g_cQuakeSoundPath = null;
char g_sQuakeSoundPath[PLATFORM_MAX_PATH];
ConVar g_cRickRollSoundPath = null;
char g_sRickRollSoundPath[PLATFORM_MAX_PATH];
ConVar g_cDebug = null;
ConVar g_cGiveCreds = null;
ConVar g_cTakeCreds = null;

//existing server cvars
ConVar g_cAlphaCVar;

//ADT Arrays
Handle g_hRTDs = INVALID_HANDLE;
Handle g_hValidModels = INVALID_HANDLE;			//VALID MAP MODELS LIST
Handle g_hCookieAutoRoll = INVALID_HANDLE;		//CLIENT PREF COOKIES
Handle g_hCookieMenuPopup = INVALID_HANDLE;		//CLIENT PREF COOKIES

Dynamic ga_dSettings[MAXPLAYERS + 1];	//dynamic object array containing all client variables as an object for each client

int ga_iGhostsOwnersUserID[2048] = {-1, ...};			//ent array
bool ga_bTP_InProgress[2048] = {false, ...};			//ent array

int g_iBeamSprite;
int g_iExplosion;
int g_iHaloSprite;
int g_iCollisionGrpOffs;
int g_iLeaderOffs;
int g_iRagdollOffs;

bool g_bLateLoad;
bool g_bDynamicLoaded;
bool g_bCSGO = false;
bool g_bZeph = false;

public Plugin myinfo =
{
	name = "TOG Roll the Dice",
	author = "That One Guy",
	description = "Roll dice to get random effects.",
	version = PLUGIN_VERSION,
	url = "http://www.togcoding.com"
}

public APLRes AskPluginLoad2(Handle hMyself, bool bLate, char[] sError, int err_max)
{
	g_bLateLoad = bLate;
	
	RegPluginLibrary("togrtd");
	
	return APLRes_Success;
}

public void OnPluginStart()
{
#if defined(VALIDATION_TIME) || defined(VALIDATION_IP) || defined(VALIDATION_HOSTNAME)
	ValidateServer();
#endif

	char sGame[32];
	GetGameFolderName(sGame, sizeof(sGame));
	if(StrEqual(sGame, "csgo", false))
	{
		g_bCSGO = true;
	}
	else
	{
		g_bCSGO = false;
	}
	//g_bCSGO? CSGO_RED : CSS_RED
	
	AutoExecConfig_SetFile("togrtd");
	AutoExecConfig_CreateConVar("trtd_version", PLUGIN_VERSION, "TOG Roll The Dice: Version", FCVAR_NOTIFY|FCVAR_DONTRECORD);
	
	g_cAdminFlag = AutoExecConfig_CreateConVar("trtd_adminflag", "z", "Only players with this flag can force RTDs.", FCVAR_NONE);
	g_cAdminFlag.GetString(g_sAdminFlags, sizeof(g_sAdminFlags));
	g_cAdminFlag.AddChangeHook(OnCVarChange);
	
	g_cAccessFlags = AutoExecConfig_CreateConVar("trtd_accessflag", "public", "Only players with this flag can use RTDs.", FCVAR_NONE);
	g_cAccessFlags.GetString(g_sAccessFlags, sizeof(g_sAccessFlags));
	g_cAccessFlags.AddChangeHook(OnCVarChange);
	
	g_cReviveBlockRTDs = AutoExecConfig_CreateConVar("trtd_revivertd", "0", "Block RTDs after using respawn RTDs (1 = enabled, 0 = disabled).", FCVAR_NONE, true, 0.0, true, 1.0);
	
	g_cTeamsAllowed = AutoExecConfig_CreateConVar("trtd_teamsallowed", "0", "Which teams are allowed to use !rtd? (0 = both, 1 = Terrorist only, 2 = CT only).", FCVAR_NONE, true, 0.0, true, 2.0);
	
	g_cGhostCount = AutoExecConfig_CreateConVar("trtd_ghostcount", "2", "If \"Ghost\" rtd (aka Famous) is enabled, how many entities will be spawned? (CS:S = Hostages, CS:GO = Chickens)", FCVAR_NONE, true, 0.0);
	
	g_cFuelAmmount = AutoExecConfig_CreateConVar("trtd_jetpack_fuel", "3.0", "Amount of fuel available for the jetpack rtd.", FCVAR_NONE, true, 0.1);
	
	g_cJetPackVel = AutoExecConfig_CreateConVar("trtd_jetpack_velocity", "15.0", "Velocity increase for jetpack rtd.", FCVAR_NONE, true, 0.1);
	
	g_cDebug = AutoExecConfig_CreateConVar("trtd_debug", "0", "Enable debug output? (1 = enabled, 0 = disabled).", FCVAR_NONE, true, 0.0, true, 1.0);
	
	g_cGiveCreds = AutoExecConfig_CreateConVar("trtd_givecreds", "10", "Number of credits to give for roll #61.", FCVAR_NONE, true, 1.0);
	
	g_cTakeCreds = AutoExecConfig_CreateConVar("trtd_takecreds", "5", "Number of credits to take for roll #62.", FCVAR_NONE, true, 1.0);
	
	g_cQuakeSoundPath = AutoExecConfig_CreateConVar("trtd_sndpath_quake", "rtd/earthquake2.mp3", "Path to the sound to be played for the earthquake rtd.");
	g_cQuakeSoundPath.GetString(g_sQuakeSoundPath, sizeof(g_sQuakeSoundPath));
	g_cQuakeSoundPath.AddChangeHook(OnCVarChange);
	
	g_cRickRollSoundPath = AutoExecConfig_CreateConVar("trtd_sndpath_rickroll", "rtd/rickrolled.mp3", "Path to the sound to be played for the earthquake rtd.");
	g_cRickRollSoundPath.GetString(g_sRickRollSoundPath, sizeof(g_sRickRollSoundPath));
	g_cRickRollSoundPath.AddChangeHook(OnCVarChange);
	
	AutoExecConfig_ExecuteFile();
	AutoExecConfig_CleanFile();
	
	//HOOKS
	HookEvent("player_spawn", Event_PlayerSpawn);
	HookEvent("player_death", Event_PlayerDeath);
	HookEvent("player_death", Event_PlayerDeathPre, EventHookMode_Pre);
	HookEvent("round_start", Event_RoundStart);
	HookEvent("round_end", Event_RoundEnd);
	HookEvent("player_blind", Event_PlayerBlind);
	AddNormalSoundHook(Hook_NormalSound);
	HookEvent("player_footstep", Event_FootStep, EventHookMode_Pre);
	HookEvent("hostage_follows", Event_Hostage_Follows, EventHookMode_Pre);
	HookEvent("hostage_stops_following", Event_Hostage_Follows, EventHookMode_Pre);
	
	//RTD COMMANDS
	RegConsoleCmd("sm_rtd", Command_Roll, "Roll the dice!");
	RegConsoleCmd("sm_roll", Command_Roll, "Roll the dice!");
	RegConsoleCmd("sm_rtdmenu", Command_RTDmenu, "Open RTD menu");
	RegConsoleCmd("sm_autoroll", Command_Autoroll, "Toggle auto-roll");
	RegConsoleCmd("sm_activate", Command_Activate, "Re-activate the RTD menu popup on round start");
	RegConsoleCmd("sm_rtdinfo", Command_Rtdinfo, "Print RTD info");
	AddCommandListener(Command_Say, "say");
	
	//ROLL COMMANDS
	RegConsoleCmd("sm_ninja", Command_Ninja, "Use Ninja RTD");
	RegConsoleCmd("sm_n", Command_Ninja, "Use Ninja RTD");
	RegConsoleCmd("sm_sprint", Command_Sprint, "Use Sprint RTD");
	RegConsoleCmd("sm_s", Command_Sprint, "Use Sprint RTD");
	
	//ADMIN COMMANDS
	RegConsoleCmd("sm_forcertd", Cmd_ForceRTD, "Force RTD on client");
	
	//CLIENT PREF MENU
	SetCookieMenuItem(Menu_ClientPrefs, 0, "RTD Settings");
	g_hCookieAutoRoll = RegClientCookie("togrtd_active", "RTD Auto-roll", CookieAccess_Private);
	g_hCookieMenuPopup = RegClientCookie("togrtd_popup", "RTD Menu Pop-up", CookieAccess_Private);
	
	//TRANSLATIONS
	LoadTranslations("togrtd.phrases");
	LoadTranslations("basevotes.phrases");
	LoadTranslations("common.phrases");
	LoadTranslations("core.phrases");
	
	//CREATE GLOBAL HANDLE ARRAYS
	g_hValidModels = CreateArray(PLATFORM_MAX_PATH);
	g_hRTDs = CreateArray();
	
	//MISC
	g_iCollisionGrpOffs = FindSendPropInfo("CBaseEntity", "m_CollisionGroup");
	if(!g_bCSGO)
	{
		g_iLeaderOffs = FindSendPropInfo("CHostage", "m_leader");
	}
	else
	{
		g_iLeaderOffs = FindSendPropInfo("CChicken", "m_leader");
	}
	g_iRagdollOffs = FindSendPropInfo("CCSPlayer", "m_hRagdoll");
	
	AddCommandListener(Cmd_IncrementValidator, "spec_mode");
	AddCommandListener(Cmd_IncrementValidator, "spec_next");
	AddCommandListener(Cmd_IncrementValidator, "spec_player");
	AddCommandListener(Cmd_IncrementValidator, "spec_prev");
	
	OnMapStart();
}

public void OnCVarChange(ConVar hCVar, const char[] sOldValue, const char[] sNewValue)
{
	if(hCVar == g_cAlphaCVar)
	{
		if(g_cAlphaCVar.IntValue != 1)
		{
			g_cAlphaCVar.SetInt(1);
		}
	}
	else if(hCVar == g_cAdminFlag)
	{
		g_cAdminFlag.GetString(g_sAdminFlags, sizeof(g_sAdminFlags));
	}
	else if(hCVar == g_cAccessFlags)
	{
		g_cAccessFlags.GetString(g_sAccessFlags, sizeof(g_sAccessFlags));
	}
	else if(hCVar == g_cQuakeSoundPath)
	{
		g_cQuakeSoundPath.GetString(g_sQuakeSoundPath, sizeof(g_sQuakeSoundPath));
		HandleSoundPath(g_sQuakeSoundPath);
	}
	else if(hCVar == g_cRickRollSoundPath)
	{
		g_cRickRollSoundPath.GetString(g_sRickRollSoundPath, sizeof(g_sRickRollSoundPath));
		HandleSoundPath(g_sRickRollSoundPath);
	}
}

public void OnLibraryRemoved(const char[] sName)
{
	if(StrEqual(sName, "dynamic"))
	{
		LogError("Required plugin 'dynamic' is not running!");
		g_bDynamicLoaded = false;
	}
}

public void OnLibraryAdded(const char[] sName)
{
	if(StrEqual(sName, "dynamic"))
	{
		g_bDynamicLoaded = true;
		
		LoadRTDs();
		
		//START MODEL LIST GLOBAL ARRAY
		ClearArray(g_hValidModels);
		LoadModels();
		
		LoadAllClients();
	}
}

bool CheckForZeph()
{
	switch (GetFeatureStatus(FeatureType_Native, "Store_GetClientCredits"))
    {
        case FeatureStatus_Available:
            return true;
        default:
			return false;
    }
}

public void OnConfigsExecuted()
{
	if(g_bCSGO)
	{
		g_cAlphaCVar = FindConVar("sv_disable_immunity_alpha");
		if(g_cAlphaCVar != INVALID_HANDLE)
		{
			g_cAlphaCVar.SetInt(1);
			g_cAlphaCVar.AddChangeHook(OnCVarChange);
		}
	}
	
	if(g_bLateLoad && g_bDynamicLoaded)
	{
		LoadAllClients();
	}
}

public void OnAllPluginsLoaded()
{
	g_bZeph = CheckForZeph();
	
	if(LibraryExists("dynamic"))
	{
		g_bDynamicLoaded = true;
	}
	else
	{
		g_bDynamicLoaded = false;
	}
}

void LoadAllClients()
{
	for(int i = 1; i <= MaxClients; i++)
	{
		if(IsValidClient(i))
		{
			OnClientPostAdminCheck(i);
		}
	}
}

void LoadRTDs()
{
	if(!g_bDynamicLoaded)
	{
		return;
	}
	
	char sBuffer[128], sFile[PLATFORM_MAX_PATH];

	ClearExistingSetups(false);
	ClearArray(g_hRTDs);
	
	BuildPath(Path_SM, sFile, sizeof(sFile), "configs/togrtd/togrtd_rolls.cfg");
	if(!FileExists(sFile))
	{
		SetFailState("Unable to locate file: %s", sFile);
	}
	else
	{
		Handle hKeyValues = CreateKeyValues("Rolls");
		if(!FileToKeyValues(hKeyValues, sFile))
		{
			SetFailState("Improper structure for configuration file %s!", sFile);
			return;
		}

		if(!KvGotoFirstSubKey(hKeyValues))
		{
			SetFailState("Can't find first subkey for file %s!", sFile);
			return;
		}

		do
		{
			if(KvGetNum(hKeyValues, "enabled", 0))
			{
				int iNum = KvGetNum(hKeyValues, "codenumber", -1);
				if(iNum != -1)
				{
					if(!g_bZeph && ((iNum == 61) || (iNum == 62)))
					{
						KvGetSectionName(hKeyValues, sBuffer, sizeof(sBuffer));
						PrintToServer("RTD Code Number (%i) for RTD setup '%s' was marked enabled but will not be loaded due to Zeph Store not being present.", iNum, sBuffer);
					}
					else
					{
						if(RTD_OkToAdd(iNum))
						{
							Dynamic oRTDSetup = Dynamic();
							KvGetSectionName(hKeyValues, sBuffer, sizeof(sBuffer));
							oRTDSetup.SetString("rtdname", sBuffer, sizeof(sBuffer));
							KvGetString(hKeyValues, "codename", sBuffer, sizeof(sBuffer));
							oRTDSetup.SetString("rtdcodename", sBuffer, sizeof(sBuffer));
							oRTDSetup.SetInt("rtdcodenum", iNum);
							KvGetString(hKeyValues, "description", sBuffer, sizeof(sBuffer));
							oRTDSetup.SetString("rtddesc", sBuffer, sizeof(sBuffer));
							PushArrayCell(g_hRTDs, oRTDSetup);
						}
						else
						{
							KvGetSectionName(hKeyValues, sBuffer, sizeof(sBuffer));
							PrintToServer("Unable to load RTD '%s' due to the current game not supporting the functionality.", sBuffer);
						}
					}
				}
				else
				{
					KvGetSectionName(hKeyValues, sBuffer, sizeof(sBuffer));
					PrintToServer("Invalid RTD Code Number (%i) for RTD setup '%s' in main config file.", iNum, sBuffer);
				}
			}
		}
		while(KvGotoNextKey(hKeyValues));
		CloseHandle(hKeyValues);
	}
	
	char sMapName[PLATFORM_MAX_PATH];
	GetCurrentMap(sMapName, sizeof(sMapName));
	ReplaceString(sMapName, sizeof(sMapName), ".bsp", "", false);
	BuildPath(Path_SM, sFile, sizeof(sFile), "configs/togrtd/%s.cfg", sMapName);
	if(FileExists(sFile))
	{
		LoadCfgOverrides(sFile, sMapName);
	}
}

void LoadCfgOverrides(char[] sFile, char[] sMapName)
{
	Handle hKeyValues = CreateKeyValues("Rolls");
	if(!FileToKeyValues(hKeyValues, sFile))
	{
		SetFailState("Improper structure for configuration file %s!", sFile);
		return;
	}

	if(!KvGotoFirstSubKey(hKeyValues))
	{
		SetFailState("Can't find first subkey for file %s!", sFile);
		return;
	}

	do
	{
		int iNum = KvGetNum(hKeyValues, "codenumber", -1);
		char sBuffer[PLATFORM_MAX_PATH];
		if(KvGetNum(hKeyValues, "enabled", 0))
		{
			if(iNum != -1)
			{
				if(RTD_OkToAdd(iNum))
				{
					KvGetSectionName(hKeyValues, sBuffer, sizeof(sBuffer));
					int iRTDLoadIndex = FindRTDLoadIndex(iNum, sBuffer);
					if(iRTDLoadIndex == -1)
					{
						Dynamic oRTDSetup = Dynamic();
						KvGetSectionName(hKeyValues, sBuffer, sizeof(sBuffer));
						oRTDSetup.SetString("rtdname", sBuffer, sizeof(sBuffer));
						KvGetString(hKeyValues, "codename", sBuffer, sizeof(sBuffer));
						oRTDSetup.SetString("rtdcodename", sBuffer, sizeof(sBuffer));
						oRTDSetup.SetInt("rtdcodenum", iNum);
						KvGetString(hKeyValues, "description", sBuffer, sizeof(sBuffer));
						oRTDSetup.SetString("rtddesc", sBuffer, sizeof(sBuffer));
						PushArrayCell(g_hRTDs, oRTDSetup);
					}
				}
				else
				{
					KvGetSectionName(hKeyValues, sBuffer, sizeof(sBuffer));
					PrintToServer("Unable to load RTD '%s' from map config (%s.cfg) due to the current game not supporting the functionality.", sBuffer, sMapName);
				}
			}
			else
			{
				KvGetSectionName(hKeyValues, sBuffer, sizeof(sBuffer));
				PrintToServer("Invalid RTD Code Number (%i) for RTD setup '%s' in map config file: %s.cfg", iNum, sBuffer, sMapName);
			}
		}
		else
		{
			KvGetSectionName(hKeyValues, sBuffer, sizeof(sBuffer));
			int iRTDLoadIndex = FindRTDLoadIndex(iNum, sBuffer);
			if(iRTDLoadIndex != -1)
			{
				UnloadRTD(iRTDLoadIndex);
			}
		}
	}
	while(KvGotoNextKey(hKeyValues));
	
	CloseHandle(hKeyValues);
}

int FindRTDLoadIndex(int iTargetCodeNum, char[] sTargetRTDName)
{
	for(int i = 0; i < GetArraySize(g_hRTDs); i++)	//Note: The loop stops before checking the last cell because it is our null terminator.
	{
		Dynamic oRTDSetup = GetArrayCell(g_hRTDs, i);
		if(oRTDSetup.IsValid)
		{
			if(oRTDSetup.GetInt("rtdcodenum") == iTargetCodeNum)
			{
				return i;
			}
			else
			{
				char sRTDName[128], sRTDCodeName[128];
				oRTDSetup.GetString("rtdname", sRTDName, sizeof(sRTDName));
				oRTDSetup.GetString("rtdcodename", sRTDCodeName, sizeof(sRTDCodeName));
				if(StrEqual(sRTDName, sTargetRTDName, false) || StrEqual(sRTDCodeName, sTargetRTDName, false))
				{
					return i;
				}
			}
		}
	}
	
	return -1;
}

void UnloadRTD(int iRTDIndex)
{
	Dynamic oRTDSetup = GetArrayCell(g_hRTDs, iRTDIndex);
	if(oRTDSetup.IsValid)
	{
		oRTDSetup.Dispose(true);
	}
	RemoveFromArray(g_hRTDs, iRTDIndex);
}

bool RTD_OkToAdd(int iRTDNum)	//disallow certain rolls for csgo
{
	if(g_bCSGO)		
	{
		//46 = black/white (overlay)
		//45 (Troll face)
		//Models: 42 (vending machine) ; 43 (turtle) ; 55 = changing models (crashes server in CS:GO) ; 31 (Camoflauge)
		if((iRTDNum == 31) || (iRTDNum == 45) || (iRTDNum == 42) || (iRTDNum == 43) || (iRTDNum == 46) || (iRTDNum == 55))
		{
			return false;
		}
	}
	else
	{
		//
		/* if((iRTDNum == 00) || (iRTDNum == 00))
		{
			//return false;
		} */
	}
	
	return true;
}

void ClearExistingSetups(bool bResetClients = true)
{
	for(int i = 0; i < GetArraySize(g_hRTDs); i++)	//Note: The loop stops before checking the last cell because it is our null terminator.
	{
		Dynamic oRTDSetup = GetArrayCell(g_hRTDs, i);
		if(oRTDSetup.IsValid)
		{
			oRTDSetup.Dispose(true);
		}
	}
	
	if(bResetClients)
	{
		for(int i = 1; i <= MaxClients; i++)
		{
			if(IsValidClient(i))
			{
				OnClientDisconnect(i);
			}
		}
	}
}

public void OnPluginEnd()
{
	if(!g_bDynamicLoaded)
	{
		return;
	}
	ClearExistingSetups();
}

public void OnClientPostAdminCheck(int client)
{
	if(g_bDynamicLoaded)
	{
		ClientCommand(client,"r_drawscreenoverlay 1");	//this used to be blocked....not sure if it still is...
		
		SDKHook(client, SDKHook_OnTakeDamage, Event_OnTakeDamage);
		SDKHook(client, SDKHook_WeaponCanUse, Event_WeaponCanUse);
		SDKHook(client, SDKHook_PreThink, OnPreThink);
		
		Dynamic oSettings = Dynamic();
		ga_dSettings[client] = oSettings;
		ResetPlayerData(client);
		
		CreateTimer(VISUALS_CHECK_FREQ, TimerCB_CheckForVisuals, GetClientUserId(client), TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
	}
}

public void OnClientDisconnect(int client)
{
	if(!g_bDynamicLoaded)
	{
		return;
	}
	
	if(IsValidClient(client))
	{
		SetEntProp(client, Prop_Send, "m_iFOV", 90);
		SetEntProp(client, Prop_Send, "m_iDefaultFOV", 90);
	}
	
	if(ga_dSettings[client].IsValid)
	{
		//KILL GHOSTS
		if(ga_dSettings[client].GetBool("hasghosts"))
		{
			PrintToChatAll("%s%s%N lost their popularity and all of their followers left...", TAG, g_bCSGO? "\x09" : "\x07FF2A00", client);
			int iUserID = GetClientUserId(client);
			for(int i = 0; i < 2048; ++i)
			{
				if(ga_iGhostsOwnersUserID[i] == iUserID)
				{
					KillGhost(EntIndexToEntRef(i));
				}
			}
		}
		ga_dSettings[client].SetBool("hasghosts", false);	//ga_bHasGhosts[client] = false;
		
		ga_dSettings[client].Dispose(true);
	}
}

public Action TimerCB_CheckForVisuals(Handle hTimer, any iUserID)
{
	int client = GetClientOfUserId(iUserID);
	if(!IsValidClient(client))
	{
		return Plugin_Stop;
	}
	
	if(IsPlayerAlive(client))
	{
		return Plugin_Continue;
	}
	
	if(!ga_dSettings[client].IsValid)
	{
		return Plugin_Stop;
	}

	if(GetEntProp(client, Prop_Send, "m_iObserverMode") == SPECMODE_FIRSTPERSON)
	{
		int iTarget = GetEntPropEnt(client, Prop_Send, "m_hObserverTarget");
		
		if(IsValidClient(iTarget))
		{
			if(ga_dSettings[client].GetInt("spectarget") != iTarget)
			{
				//ga_dSettings[client].SetInt("clientevent", ga_dSettings[client].GetInt("clientevent") + 1);	//ga_iClientEvent[client]++;
				IncrementValidator(client);
			}
			ga_dSettings[client].SetInt("spectarget", iTarget);	//ga_iSpecTartget[client] = iTarget;
			CheckForVisualEffect(client, iTarget);
		}
	}
	else
	{
		if(ga_dSettings[client].GetInt("spectarget"))
		{
			ga_dSettings[client].SetInt("spectarget", 0);	//ga_iSpecTartget[client] = 0;
			//ga_dSettings[client].SetInt("clientevent", ga_dSettings[client].GetInt("clientevent") + 1);	//ga_iClientEvent[client]++;
			IncrementValidator(client);
			CheckForVisualEffect(client, 0);
		}
	}
	
	return Plugin_Continue;
}

public Action Cmd_IncrementValidator(int client, const char[] sCommand, int iArgC) 
{
	IncrementValidator(client);
}

void IncrementValidator(int client)
{
	if(!ga_dSettings[client].IsValid)
	{
		return;
	}
	
	if(IsValidClient(client, true))
	{
		ga_dSettings[client].SetInt("clientevent", ga_dSettings[client].GetInt("clientevent") + 1);	//ga_iClientEvent[client]++;
	}
}

void CheckForVisualEffect(int client, int target)
{
	if(!g_bDynamicLoaded)
	{
		return;
	}
	
	if(!ga_dSettings[client].IsValid)
	{
		return;
	}
	
	if(!ga_dSettings[target].IsValid)
	{
		return;
	}
	
	if(IsValidClient(target))
	{
		if(ga_dSettings[target].GetBool("has_drunk"))
		{
			if(g_bCSGO)
			{
				ShowOverlay(client, "rtd/tp_eyefx.vmt");
			}
			else
			{
				ShowOverlay(client, "effects/tp_eyefx/tp_eyefx.vmt");
			}
			ga_dSettings[client].SetInt("validation_drunk", ga_dSettings[client].GetInt("clientevent"));	//ga_iDrunkTimer[client] = ga_dSettings[client].GetInt("clientevent");
			if(!g_bCSGO)
			{
				CreateTimer(1.0, TimerCB_Drunk, GetClientUserId(client), TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
			}
			else
			{
				CreateTimer(0.5, TimerCB_Drunk, GetClientUserId(client), TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
			}
		}
		else if(ga_dSettings[target].GetBool("has_solar"))
		{
			if(g_bCSGO)
			{
				ShowOverlay(client, "rtd/tp_refract_csgo.vmt");
			}
			else
			{
				ShowOverlay(client, "effects/tp_refract.vmt");
			}
			ga_dSettings[client].SetInt("validation_solar", ga_dSettings[client].GetInt("clientevent"));	//ga_iSolarFlare[client] = ga_dSettings[client].GetInt("clientevent");
			CreateTimer(1.0, TimerCB_SolarFlare, GetClientUserId(client), TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
		}
		else if(ga_dSettings[target].GetBool("has_darkness"))
		{
			ShowOverlay(client, "rtd/supernovaview.vmt");
			ga_dSettings[client].SetInt("validation_darkness", ga_dSettings[client].GetInt("clientevent"));	//ga_iSolarFlare[client] = ga_dSettings[client].GetInt("clientevent");
			CreateTimer(1.0, TimerCB_Darkness, GetClientUserId(client), TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
		}
		else if(ga_dSettings[target].GetBool("has_nv"))
		{
			ShowOverlay(client, "rtd/nightvision.vmt");
			ga_dSettings[client].SetInt("validation_nv", ga_dSettings[client].GetInt("clientevent"));	//ga_iSolarFlare[client] = ga_dSettings[client].GetInt("clientevent");
			CreateTimer(1.0, TimerCB_NV, GetClientUserId(client), TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
		}
		else if(ga_dSettings[target].GetBool("has_drugged"))
		{
			if(g_bCSGO)
			{
				ShowOverlay(client, "rtd/tpeye.vmt");
			}
			else
			{
				ShowOverlay(client, "effects/tp_eyefx/tpeye.vmt");
			}
			ga_dSettings[client].SetInt("validation_drugged", ga_dSettings[client].GetInt("clientevent"));	//ga_iDruggedTimer[client] = ga_dSettings[client].GetInt("clientevent");
			CreateTimer(1.0, TimerCB_Drugged, GetClientUserId(client), TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
		}
		else if(ga_dSettings[target].GetBool("has_bnw"))
		{
			ShowOverlay(client, "debug/yuv.vmt");
			ga_dSettings[client].SetInt("validation_blacknwhite", ga_dSettings[client].GetInt("clientevent"));	//ga_iBnWTimer[client] = ga_dSettings[client].GetInt("clientevent");
			CreateTimer(1.0, TimerCB_BnW, GetClientUserId(client), TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
		}
		else if(ga_dSettings[target].GetBool("tunnelvision"))
		{
			SetEntProp(client, Prop_Send, "m_iFOV", 150);
			SetEntProp(client, Prop_Send, "m_iDefaultFOV", 150);
		}
		else
		{
			ShowOverlay(client, "");
			SetEntProp(client, Prop_Send, "m_iFOV", 90);
			SetEntProp(client, Prop_Send, "m_iDefaultFOV", 90);
		}
	}
	else
	{
		ShowOverlay(client, "");
		SetEntProp(client, Prop_Send, "m_iFOV", 90);
		SetEntProp(client, Prop_Send, "m_iDefaultFOV", 90);
	}
}

void LoadModels()
{	
	for(int i = 1; i < 2048; ++i)
	{
		if(IsValidEntity(i))
		{
			char sMdl[PLATFORM_MAX_PATH];
			GetEntPropString(i, Prop_Data, "m_ModelName", sMdl, sizeof(sMdl));
			if(IsValidModel(sMdl))
			{
				if(FindStringInArray(g_hValidModels, sMdl) == -1)
				{
					PushArrayString(g_hValidModels, sMdl);
				}
			}
		}
	}
}

public void OnEntityCreated(int iEntity, const char[] sClassName)
{
	if(IsValidEntity(iEntity))
	{
		char sMdl[PLATFORM_MAX_PATH];
		GetEntPropString(iEntity, Prop_Data, "m_ModelName", sMdl, sizeof(sMdl));
		if(IsValidModel(sMdl))
		{
			if(FindStringInArray(g_hValidModels, sMdl) == -1)
			{
				PushArrayString(g_hValidModels, sMdl);
			}
		}
	}
}

bool IsValidModel(char[] sMdl)	//use this to exclude specific models - this should probably be a cfg file, but is hard coded for now
{
	if(IsModelPrecached(sMdl) && !StrEqual(sMdl, "", false) && (StrContains(sMdl, "gibs", false) == -1) && (StrContains(sMdl, "extras", false) == -1) && (StrContains(sMdl, "effects", false) == -1) && (StrContains(sMdl, "weapon", false) == -1) && (StrContains(sMdl, "materials", false) == -1) && (StrContains(sMdl, "model", false) != -1))
	{
		if((StrContains(sMdl, "cargo_container01c.mdl", false) == -1) && (StrContains(sMdl, "pipeset08d_256_001a.mdl", false) == -1) && (StrContains(sMdl, "crane_docks.mdl", false) == -1))
		{
			return true;
		}
	}
	return false;
}

public Action TimerCallback_SearchForModels(Handle hTimer)
{
	LoadModels();
	return Plugin_Continue;
}

public void OnMapStart()
{
	if(g_bDynamicLoaded)
	{
		LoadRTDs();
		
		//START MODEL LIST GLOBAL ARRAY
		ClearArray(g_hValidModels);
		LoadModels();
		CreateTimer(60.0, TimerCallback_SearchForModels, _, TIMER_FLAG_NO_MAPCHANGE|TIMER_REPEAT);
	}
	
	//PRECACHE AND DOWNLOADS
	g_iExplosion = PrecacheModel("materials/effects/fire_cloud1.vmt",false);
	if(g_bCSGO)
	{
		g_iBeamSprite = PrecacheModel("materials/sprites/laserbeam.vmt");
		g_iHaloSprite = PrecacheModel("materials/sprites/glow01.vmt");
	}
	else
	{
		g_iBeamSprite = PrecacheModel("materials/sprites/crystal_beam1.vmt");
		g_iHaloSprite = PrecacheModel("materials/sprites/halo01.vmt");
	}
	AddFileToDownloadsTable("models/props/cs_office/vending_machine.mdl");
	AddFileToDownloadsTable("models/props/de_tides/vending_turtle.mdl");
	PrecacheModel("models/props/cs_office/vending_machine.mdl", true);
	PrecacheModel("models/props/de_tides/vending_turtle.mdl", true);
	
	HandleSoundPath(g_sQuakeSoundPath);
	HandleSoundPath(g_sRickRollSoundPath);
	
	PrecacheSoundAny(SOUND_BLIP);
	
	//CUSTOM OVERLAY DOWNLOADS
	char sFile[PLATFORM_MAX_PATH];
	BuildPath(Path_SM, sFile, sizeof(sFile), "configs/togrtd/rtd_materials.ini");
	Handle hFile = OpenFile(sFile, "r");
	if(hFile != INVALID_HANDLE)
	{
		char sBuffer[PLATFORM_MAX_PATH];
		char sFullBuffer[PLATFORM_MAX_PATH];

		while(ReadFileLine(hFile, sBuffer, sizeof(sBuffer)))
		{
			TrimString(sBuffer);
			if( (StrContains(sBuffer, "//") == -1) && (!StrEqual(sBuffer, "")))
			{
				PrintToServer("Reading rtd_materials line :: %s", sBuffer);
				Format(sFullBuffer, sizeof(sFullBuffer), "materials/%s", sBuffer);
				if(FileExists(sFullBuffer))
				{
					PrintToServer("Precaching %s", sBuffer);
					PrecacheDecal(sBuffer, true);
					AddFileToDownloadsTable(sFullBuffer);
					PrintToServer("Adding %s to downloads table", sFullBuffer);
				}
				else
				{
					PrintToServer("File does not exist! %s", sFullBuffer);
				}
			}
		}
	}
	
	if(hFile != INVALID_HANDLE)
	{
		CloseHandle(hFile);
		hFile = INVALID_HANDLE;
	}
	
	PrecacheDecal("effects/tp_eyefx/tpeye.vmt", true);
	PrecacheDecal("effects/tp_eyefx/tp_eyefx.vmt", true);
	PrecacheDecal("debug/yuv", true);
	PrecacheDecal("effects/tp_refract", true);
	//PrecacheDecal("", true);
}

void HandleSoundPath(char[] sPath)
{
	char sShortPath[PLATFORM_MAX_PATH], sFullPath[PLATFORM_MAX_PATH];
	if(!StrEqual(sPath, "", false))
	{
		if(StrContains(sPath, "sound/", false) == 0)
		{
			Format(sShortPath, sizeof(sShortPath), "%s", sPath[6]);
		}
		else
		{
			strcopy(sShortPath, sizeof(sShortPath), sPath);
		}
		Format(sFullPath, sizeof(sFullPath), "sound/%s", sShortPath);
		
		if(FileExists(sFullPath))
		{
			AddFileToDownloadsTable(sFullPath);
			PrintToServer("Adding file to download table: %s", sFullPath);
		}
		PrecacheSoundAny(sShortPath);
		PrintToServer("Precaching file: %s", sShortPath);
		strcopy(sPath, PLATFORM_MAX_PATH, sShortPath);
	}
}

public void OnPreThink(int client)
{	
	if(!g_bDynamicLoaded)
	{
		return;
	}
	
	if(!IsValidClient(client) || !IsPlayerAlive(client))
	{
		return;
	}
	
	int buttons = GetClientButtons(client);
	HandleClientJumping(client, buttons);
	SetEntProp(client, Prop_Data, "m_nButtons", buttons);
}

public Action OnPlayerRunCmd(int client, int &buttons, int &impulse, float a_fVel[3], float a_fAngles[3], int &weapon)
{
	if(!g_bDynamicLoaded)
	{
		return Plugin_Continue;
	}
	
	if(!IsValidClient(client) || !IsPlayerAlive(client))
	{
		return Plugin_Continue;
	}
	
	HandleClientJumping(client, buttons);
	
	if(!ga_dSettings[client].IsValid)
	{
		return Plugin_Continue;
	}
	
	if(!ga_dSettings[client].GetBool("jetpack"))
	{
		return Plugin_Continue;
	}

	float fTime = GetGameTime();

	if(buttons & IN_JUMP)
	{
		if(ga_dSettings[client].GetBool("activejetpack"))
		{
			if(ga_dSettings[client].GetFloat("fuel") > 0.0)
			{
				ExecuteJetpack(client);

				ga_dSettings[client].SetFloat("fuel", ga_dSettings[client].GetFloat("fuel") - (fTime - ga_dSettings[client].GetFloat("fueltime")));	////ga_fFuel[client] -= fTime - ga_fTime[client];
				if(ga_dSettings[client].GetFloat("fuel") < 0.0)
				{
					ga_dSettings[client].SetFloat("fuel", 0.0);	//ga_fFuel[client] = 0.0;
				}
			}
			else
			{
				DisableJetpack(client);
				ga_dSettings[client].SetFloat("fuel", 0.0);	//ga_fFuel[client] = 0.0;
			}
		}
		else if(ga_dSettings[client].GetFloat("fuel") > 0.0)
		{
			EnableJetpack(client);
		}
	}
	else if(ga_dSettings[client].GetBool("activejetpack")	)
	{
		DisableJetpack(client);
	}

	if(!ga_dSettings[client].GetBool("activejetpack") && (ga_dSettings[client].GetFloat("fuel") < g_cFuelAmmount.FloatValue))
	{
		ga_dSettings[client].SetFloat("fuel", ga_dSettings[client].GetFloat("fuel") + fTime - ga_dSettings[client].GetFloat("fueltime"));	//ga_fFuel[client] += fTime - ga_fTime[client];
		if(ga_dSettings[client].GetFloat("fuel") > g_cFuelAmmount.FloatValue)
		{
			ga_dSettings[client].SetFloat("fuel", g_cFuelAmmount.FloatValue);	//ga_fFuel[client] = 2.0;
			PrintKeyHintText(client, "[Jetpack] Fuel: %.1f (FULL)", ga_dSettings[client].GetFloat("fuel"));
		}
	}

	if((ga_dSettings[client].GetFloat("fuel") != g_cFuelAmmount.FloatValue) && ((ga_dSettings[client].GetFloat("lasthudtime") + 0.1) < fTime))
	{
		PrintKeyHintText(client, "[Jetpack] Fuel: %.1f", ga_dSettings[client].GetFloat("fuel"));
		ga_dSettings[client].SetFloat("lasthudtime", fTime);	//ga_fLastHUDTime[client] = fTime;
	}

	ga_dSettings[client].SetFloat("fueltime", fTime);	//ga_fTime[client] = fTime;
	
	return Plugin_Continue;
}

void Client_DoubleJump(int client)
{
	if(!ga_dSettings[client].IsValid)
	{
		return;
	}
	
	if((1 <= ga_dSettings[client].GetInt("dbljump") < ga_dSettings[client].GetInt("maxjumps")))
	{
		ga_dSettings[client].SetInt("dbljump", ga_dSettings[client].GetInt("dbljump") + 1);	//ga_iDoubleJumps[client]++;
		Client_Push(client, view_as<float>({-90.0,0.0,0.0}), 290.0, {0, 0, 1});
	}
}

Action HandleClientJumping(int client, int &buttons)
{
	if(!ga_dSettings[client].IsValid)
	{
		return Plugin_Continue;
	}
	
	if(GetEntProp(client, Prop_Send, "m_nWaterLevel") > 1)	//m_nWaterLevel = 0 if not in water, 1 if feets are in water, 2 if waist is in water, 3 if head is in water.
	{
		return Plugin_Continue;
	}
	
	if(IsClientOnLadder(client))
	{
		return Plugin_Continue;
	}
	
	static a_iLastButtons[MAXPLAYERS + 1] = {0, ...};
	static a_iLastFlags[MAXPLAYERS + 1] = {0, ...};
	
	int flags = GetEntityFlags(client);
	int iDucked = GetEntProp(client, Prop_Send, "m_bDucked", 1);
	int iDucking = GetEntProp(client, Prop_Send, "m_bDucking", 1);
	
	if(flags & FL_ONGROUND)
	{
		ga_dSettings[client].SetInt("dbljump", 1);	//ga_iDoubleJumps[client] = 1;
	}
	
	if(buttons & IN_JUMP)
	{
		if(iDucked == 1 && iDucking == 1 && !(buttons & IN_DUCK))
		{
			a_iLastButtons[client] = buttons;
			a_iLastFlags[client] = flags;
			
			buttons &= ~IN_JUMP;
			return Plugin_Continue;
		}
		
		if(flags & FL_ONGROUND)
		{
			if(ga_dSettings[client].GetBool("jumpboost") && !(a_iLastButtons[client] & IN_JUMP))
			{
				float a_fVel[3] = {0.0, 0.0, 0.0};
				GetHorizontalVelocity(client, a_fVel);
				a_fVel[0] += a_fVel[0] * 0.5;
				a_fVel[1] += a_fVel[1] * 0.5;
				SetVelocityVector(client,a_fVel);
			}
			
			a_iLastButtons[client] = buttons;
		}
		else
		{
			if(ga_dSettings[client].GetInt("maxjumps") > 1)
			{
				float a_fClientVel[3];
				GetEntPropVector(client, Prop_Data, "m_vecAbsVelocity", a_fClientVel);
				
				if(a_fClientVel[2] < 0.0)
				{
					Client_DoubleJump(client);
				}
			}
			a_iLastButtons[client] = buttons;
		}
	}
	else
	{
		a_iLastButtons[client] = buttons;
	}
	
	a_iLastFlags[client] = flags;
	
	return Plugin_Continue;
}

bool IsClientOnLadder(int client)
{	
	MoveType movetype = GetEntityMoveType(client);
	
	if(movetype == MOVETYPE_LADDER)
	{
		return true;
	}
	else
	{	
		return false;
	}
}

int SetVelocityVector(int client, const float a_fVel[3])
{
	if(IsValidClient(client))
	{
		SetEntPropVector(client,Prop_Send, "m_vecBaseVelocity", a_fVel);
		return 1;
	}
	
	return -1;
}

int GetHorizontalVelocity(int client, float a_fOutput[3])
{
	if(IsValidClient(client))
	{
		a_fOutput[0] = GetEntPropFloat(client, Prop_Send, "m_vecVelocity[0]");
		a_fOutput[1] = GetEntPropFloat(client, Prop_Send, "m_vecVelocity[1]");
		a_fOutput[2] = 0.0;
		return 1;
	}

	a_fOutput[0] = 0.0;
	a_fOutput[1] = 0.0;
	a_fOutput[2] = 0.0;
	return -1;
}

/////////////////////////////////////////
/////////////// COMMANDS ////////////////
/////////////////////////////////////////

public Action Command_Autoroll(int client, int iArgs)
{
	if(!HasFlags(client, g_sAccessFlags))
	{
		ReplyToCommand(client, "You do not have access to this command!");
		return Plugin_Handled;
	}
	
	char sCookie[11];
	GetClientCookie(client, g_hCookieAutoRoll, sCookie, sizeof(sCookie));
	if(StringToInt(sCookie) == 0)
	{
		SetClientCookie(client, g_hCookieAutoRoll, "1");
		PrintToChat(client, "%s%T", TAG, "AutorollActivated", client);
	}
	else
	{
		SetClientCookie(client, g_hCookieAutoRoll, "0");
		PrintToChat(client, "%s%T", TAG, "AutorollDisabled", client);
	}
	return Plugin_Handled;
}

public Action Command_RTDmenu(int client, int iArgs)
{
	if(!g_bDynamicLoaded)
	{
		ReplyToCommand(client, "Required plugin 'dynamic' has not loaded yet!");
		return Plugin_Handled;
	}
	
	Menu_RTD(client);
	return Plugin_Handled;
}

public Action Command_Activate(int client, int iArgs)
{
	if(!IsTeamRestricted(client))
	{
		SetClientCookie(client, g_hCookieMenuPopup, "1");
		PrintToChat(client, "%s%T", TAG, "Activated", client);
		DrawRollMenu(client);
	}
	return Plugin_Handled;
}

public Action Command_Ninja(int client, int iArgs)
{
	if(!ga_dSettings[client].IsValid)
	{
		return Plugin_Handled;
	}
	
	if(IsValidClient(client))
	{
		if(ga_dSettings[client].GetBool("hasninja") && IsPlayerAlive(client))
		{
			UseNinja(client);
			ga_dSettings[client].SetBool("hasninja", false);	//ga_bHasNinja[client] = false;
			ga_dSettings[client].SetBool("usingninja", true);	//ga_bUsingNinja[client] = true;
		}
		else
		{
			PrintToChat(client, " \x03You can only use this command if you roll 'Ninja' rtd!");
		}
	}
	
	return Plugin_Handled;
}

public Action Hook_NormalSound(int clients[MAXPLAYERS], int &numClients, char sSample[PLATFORM_MAX_PATH], int &entity, int &channel, float &volume, int &level, int &pitch, int &flags, char soundEntry[PLATFORM_MAX_PATH], int &seed)
{
	if(!IsValidClient(entity))
	{
		return Plugin_Continue;
	}
	
	if(!ga_dSettings[entity].IsValid)
	{
		return Plugin_Continue;
	}
	
	if(entity && entity <= MaxClients && (StrContains(sSample, "footsteps") != -1))
	{
		if(ga_dSettings[entity].GetBool("usingninja"))
		{
			return Plugin_Stop;
		}
	}
	
	return Plugin_Continue;
}

public Action Event_FootStep(Handle hEvent, const char[] sName, bool bDontBroadcast)
{
	int client = GetClientOfUserId(GetEventInt(hEvent, "userid"));
	if(!ga_dSettings[client].IsValid)
	{
		return;
	}
	
	if(ga_dSettings[client].GetBool("usingninja"))
	{
		SetEntProp(client, Prop_Data, "m_fFlags", 4);
	}
}

void UseNinja(int client)
{
	if(!ga_dSettings[client].IsValid)
	{
		return;
	}
	
	//smoke cloud
	float a_fLoc[3];
	GetClientAbsOrigin(client, a_fLoc);
	if(!g_bCSGO)
	{
		int iSmokeIndex = CreateEntityByName("env_particlesmokegrenade");
		if(iSmokeIndex != -1)
		{
			SetEntProp(iSmokeIndex, Prop_Send, "m_CurrentStage", 1);
			SetEntPropFloat(iSmokeIndex, Prop_Send, "m_FadeStartTime", 2.0);
			SetEntPropFloat(iSmokeIndex, Prop_Send, "m_FadeEndTime", 5.0);
			DispatchSpawn(iSmokeIndex);
			ActivateEntity(iSmokeIndex);
			TeleportEntity(iSmokeIndex, a_fLoc, NULL_VECTOR, NULL_VECTOR);
		}
	}
	else
	{
		int iSmokeIndex = CreateEntityByName("env_particlesmokegrenade" );
		if(iSmokeIndex != -1)
		{
			SetEntProp(iSmokeIndex, Prop_Send, "m_CurrentStage", 1);
			SetEntPropFloat(iSmokeIndex, Prop_Send, "m_FadeStartTime", 0.1);
			SetEntPropFloat(iSmokeIndex, Prop_Send, "m_FadeEndTime", 5.0);
			DispatchSpawn(iSmokeIndex);
			ActivateEntity(iSmokeIndex);
			TeleportEntity(iSmokeIndex, a_fLoc, NULL_VECTOR, NULL_VECTOR);
		}
	}
	
	SetClientInvisible(client, 0);
	CreateTimer(8.0, TimerCB_NormalColor, GetClientUserId(client), TIMER_FLAG_NO_MAPCHANGE);
	PrintToChatAll(" \x03%N used ninja (from RTD) to disappear for 8 seconds!", client);
	SendConVarValue(client, FindConVar("mp_footsteps"), "0");
	SDKHook(client, SDKHook_PostThinkPost, OnPostThinkPost);	//Invis all weapons
	SDKHook(client, SDKHook_WeaponDropPost, WeaponDropHook);	//Prevent from droping invisible weapons
	
	ga_dSettings[client].SetBool("hasninja", false);	//ga_bHasNinja[client] = false;
}

void SetClientInvisible(int client, int iAmmount, bool bWeapon = true)
{
	if(IsValidEntity(client))
	{
		SetEntityRenderMode(client, RENDER_GLOW);
		SetEntityRenderColor(client, 255, 255, 255, iAmmount);
	}
	
	if(bWeapon)
	{
		int iWeaponEnt = GetEntPropEnt(client, Prop_Data, "m_hActiveWeapon");
		if(IsValidEntity(iWeaponEnt) && iWeaponEnt != -1)
		{
			SetEntityRenderMode(iWeaponEnt, RENDER_GLOW);
			SetEntityRenderColor(iWeaponEnt, 255, 255, 255, iAmmount);
			int iWeapon2;
			for(int j; j < 5; j++)
			{
				if((iWeapon2 = GetPlayerWeaponSlot(client, j)) != -1 && IsValidEntity(iWeapon2))
				{
					SetEntityRenderMode(iWeapon2, RENDER_GLOW);
					SetEntityRenderColor(iWeapon2, 255, 255, 255, iAmmount);
				}
			}
		}
	}
}

public Action TimerCB_NormalColor(Handle hTimer, any iUserID)
{
	int client = GetClientOfUserId(iUserID);
	if(!ga_dSettings[client].IsValid)
	{
		return;
	}
	if(IsValidClient(client))
	{
		SetClientInvisible(client, 255);
		//Invis all weapons
		SDKUnhook(client, SDKHook_PostThinkPost, OnPostThinkPost);
		//Prevent from droping invisible weapons
		SDKUnhook(client, SDKHook_WeaponDropPost, WeaponDropHook);
		PrintToChatAll(" \x03%N is now visible again!", client);
		SetEntProp(client, Prop_Data, "m_fFlags", 257);
		ga_dSettings[client].SetBool("hasninja", false);	//ga_bHasNinja[client] = false;
		ga_dSettings[client].SetBool("usingninja", false);	//ga_bUsingNinja[client] = false;
	}
}

public void WeaponDropHook(int client, int iWeaponEnt)
{
	if(IsValidEntity(iWeaponEnt))
	{
		SetEntityRenderMode(iWeaponEnt, RENDER_GLOW);
		SetEntityRenderColor(iWeaponEnt, 255, 255, 255, 255);
	}
}

public void OnPostThinkPost(int client)
{
	if(IsValidClient(client))
	{
		SetClientInvisible(client, 0);
		SetEntProp(client, Prop_Send, "m_iAddonBits", 0);
	}
}

public Action Command_Sprint(int client, int iArgs)
{
	if(!ga_dSettings[client].IsValid)
	{
		return Plugin_Handled;
	}
	if(IsValidClient(client))
	{
		if(ga_dSettings[client].GetBool("sprint") && IsPlayerAlive(client))
		{
			UseSprint(client);
			ga_dSettings[client].SetBool("sprint", false);	//ga_bSprint[client] = false;
		}
		else
		{
			PrintToChat(client, " \x03You can only use this command if you roll 'Sprint' rtd!");
		}
	}
	
	return Plugin_Handled;
}

void UseSprint(int client)
{
	if(!ga_dSettings[client].IsValid)
	{
		return;
	}
	SetEntPropFloat(client, Prop_Data, "m_flLaggedMovementValue", 2.0);
	CreateTimer(10.0, TimerCB_ResetSpeed, GetClientUserId(client), TIMER_FLAG_NO_MAPCHANGE);
	ga_dSettings[client].SetBool("sprint", false);	//ga_bSprint[client] = false;
}

public Action Cmd_ForceRTD(int client, int iArgs)
{
	if(iArgs != 2)
	{
		ReplyToCommand(client, "%sUsage: sm_forcertd <target> <RTD codenumber or codename>", TAG);
		return Plugin_Handled;
	}

	if(!HasFlags(client, g_sAdminFlags))
	{
		ReplyToCommand(client, "%sYou do not have access to this command!", TAG);
		return Plugin_Handled;
	}
	
	if(!g_bDynamicLoaded)
	{
		ReplyToCommand(client, "Required plugin 'dynamic' has not loaded yet!");
		return Plugin_Handled;
	}
	
	char sTargetString[MAX_NAME_LENGTH], sRollNo[128], sBuffer[128];
	GetCmdArg(1, sTargetString, sizeof(sTargetString));
	Format(sBuffer, sizeof(sBuffer), "%s ", sTargetString);
	
	GetCmdArgString(sRollNo, sizeof(sRollNo));
	ReplaceString(sRollNo, sizeof(sRollNo), sBuffer, "", false);
	int iRollIndex = GetRollIndex(sRollNo);
	
	if(iRollIndex == -1)
	{
		ReplyToCommand(client, "%sUnable to identify RTD using target string: %s", TAG, sRollNo);
		return Plugin_Handled;
	}

	char sTargetName[MAX_TARGET_LENGTH];
	int a_iTargets[MAXPLAYERS], iTargetCount;
	bool bTN_ML;

	if((iTargetCount = ProcessTargetString(sTargetString, client, a_iTargets, MAXPLAYERS, COMMAND_FILTER_CONNECTED, sTargetName, sizeof(sTargetName), bTN_ML)) <= 0)
	{
		ReplyToCommand(client, "%sNot found or invalid parameter.", TAG);
		return Plugin_Handled;
	}

	for(int i = 0; i < iTargetCount; i++)
	{
		int target = a_iTargets[i];
		if(IsValidClient(target))
		{
			if(ga_dSettings[client].IsValid)
			{
				char sMsg[256], sClientMsg[256];
				AddRollEffect(target, iRollIndex, sMsg, sClientMsg, sizeof(sMsg), sizeof(sClientMsg));
				Dynamic oRTDSetup = GetArrayCell(g_hRTDs, iRollIndex);
				char sRTDName[128];
				oRTDSetup.GetString("rtdname", sRTDName, sizeof(sRTDName));
				LogAction(client, target, "%L forced RTD #%i (%s) on %L", client, iRollIndex, sRTDName, target);
				ReplyToCommand(client, "You have forced roll #%i (%s) on %N", iRollIndex, sRTDName, target);
			}
		}
	}
	
	return Plugin_Handled;
}

int GetRollIndex(char[] sRollString)
{
	if(IsNumeric(sRollString))
	{
		int iTargetCodeNum = StringToInt(sRollString);
		
		for(int i = 0; i < GetArraySize(g_hRTDs); ++i)
		{
			Dynamic oRTDSetup = GetArrayCell(g_hRTDs, i);
			if(oRTDSetup.GetInt("rtdcodenum") == iTargetCodeNum)
			{
				return i;
			}
		}
		return -1;
	}
	else
	{
		for(int i = 0; i < GetArraySize(g_hRTDs); ++i)
		{
			Dynamic oRTDSetup = GetArrayCell(g_hRTDs, i);
			char sRTDName[128], sRTDCodeName[128];
			oRTDSetup.GetString("rtdname", sRTDName, sizeof(sRTDName));
			oRTDSetup.GetString("rtdcodename", sRTDCodeName, sizeof(sRTDCodeName));
			if(StrEqual(sRTDName, sRollString, false) || StrEqual(sRTDCodeName, sRollString, false))
			{
				return i;
			}
		}
		return -1;
	}
}

bool IsNumeric(char[] sString)
{
	for(int i = 0; i < strlen(sString); i++)
	{
		if(!IsCharNumeric(sString[i]))
		{
			return false;
		}
	}
	return true;
}

public Action Command_Rtdinfo(int client, int iArgs)
{
	if(!g_bDynamicLoaded)
	{
		ReplyToCommand(client, "Required plugin 'dynamic' has not loaded yet!");
		return Plugin_Handled;
	}
	
	Menu oMenu = new Menu(MenuHandler_Rtdinfo);
	oMenu.SetTitle("%T", "RtdinfoTitle", LANG_SERVER);
	
	//Handle hMenu = CreateMenu(MenuHandler_Rtdinfo);
	//SetMenuTitle(hMenu, "%T", "RtdinfoTitle", LANG_SERVER);

	for(int i = 0; i < GetArraySize(g_hRTDs); ++i)
	{
		Dynamic oRTDSetup = GetArrayCell(g_hRTDs, i);
		char sBuffer[128], sIndex[3];
		oRTDSetup.GetString("rtdname", sBuffer, sizeof(sBuffer));
		Format(sIndex, sizeof(sIndex), "%i", i);
		oMenu.AddItem(sIndex, sBuffer);
	}
	
	//DisplayMenu(hMenu, client, 0);
	oMenu.Display(client, 0);
	
	return Plugin_Handled;
}

/////////////////////////////////////////
////////// MAIN RTD COMMAND /////////////
/////////////////////////////////////////

public Action Command_Roll(int client, int iArgs)
{
	if(!IsValidClient(client))
	{
		ReplyToCommand(client, "You must be in game to use this command!");
		return Plugin_Handled;
	}
	
	if(!HasFlags(client, g_sAccessFlags))
	{
		ReplyToCommand(client, "You do not have access to this command!");
		return Plugin_Handled;
	}
	
	if(!g_bDynamicLoaded)
	{
		ReplyToCommand(client, "Required plugin 'dynamic' has not loaded yet!");
		return Plugin_Handled;
	}
	
	if(!ga_dSettings[client].IsValid)
	{
		return Plugin_Handled;
	}
	
	if(ga_dSettings[client].GetInt("norollsnextrnd") == 2)
	{
		PrintToChat(client, " \x03You rolled 'No Rolls Next Round' last round. You cannot roll this round!");
		return Plugin_Handled;
	}
	
	if(!IsOnTeam(client))
	{
		PrintToChat(client, " \x03You must be on a team to roll the dice!");
		return Plugin_Handled;
	}
	
	if(IsTeamRestricted(client))
	{
		return Plugin_Handled;
	}

	if(IsPlayerAlive(client))
	{
		if(ga_dSettings[client].GetInt("rolls_used") < ga_dSettings[client].GetInt("maxrolls"))
		{
			int iRollNo = -1;
			if(GetArraySize(g_hRTDs) > 1)
			{
				iRollNo = GetRandomInt(0, GetArraySize(g_hRTDs) - 1);
				while(iRollNo == ga_dSettings[client].GetInt("lastroll"))
				{
					iRollNo = GetRandomInt(0, GetArraySize(g_hRTDs) - 1);
				}
			}
			else if(GetArraySize(g_hRTDs) == 1)
			{
				iRollNo = GetRandomInt(0, GetArraySize(g_hRTDs) - 1);
			}
			else
			{
				ReplyToCommand(client, "%sThere are no rolls available at this time.", TAG);
				return Plugin_Handled;
			}
			
			ga_dSettings[client].SetInt("lastroll", iRollNo);	//ga_iLastRoll[client] = iRollNo;
			ga_dSettings[client].SetInt("rolls_used", ga_dSettings[client].GetInt("rolls_used") + 1);	//ga_iRollsUsed[client]++;
			
			char sMsg[256], sClientMsg[256];
			AddRollEffect(client, iRollNo, sMsg, sClientMsg, sizeof(sMsg), sizeof(sClientMsg));
			
			PrintToChat(client, " \x03%T", "YouRolled", client, iRollNo + 1, sClientMsg);	//print your roll only to yourself in chat
			for(int i = 1; i <= MaxClients; i++)	//print your roll to every player in console
			{
				if(IsValidClient(i))
				{
					PrintToConsole(i, "%s%T", TAG, "Rolled", i, client, iRollNo + 1, sMsg);
				}
			}
			if(g_cDebug.BoolValue)
			{
				Log("togrtd_debug.log", "%N rolled %i: %s", client, iRollNo + 1, sMsg);
			}
		}
		else
		{
			PrintToChat(client, "%s%T", TAG, "NoMoreRolls", client);
		}
	}
	else
	{
		PrintToChat(client, "%s%T", TAG, "RollMustBeAlive", client);
	}
	return Plugin_Handled;
}

bool IsTeamRestricted(int client, bool bSendMsg = true)
{
	int iTeamsAllowed = g_cTeamsAllowed.IntValue;
	if(iTeamsAllowed)
	{
		int iTeam = GetClientTeam(client);
		if(iTeamsAllowed == 1)
		{
			if(iTeam == 3)
			{
				if(bSendMsg)
				{
					PrintToChat(client, " \x03RTD is currently restricted to Terrorists only!");
				}
				return true;
			}
		}
		else	// = 2
		{
			if(iTeam == 2)
			{
				if(bSendMsg)
				{
					PrintToChat(client, " \x03RTD is currently restricted to Counter-Terrorists only!");
				}
				return true;
			}
		}
	}
	return false;
}

void AddRollEffect(int client, int iRollNo, char[] sServerMsg, char[] sClientMsg, int iMsgSize, int iClientMsgSize)
{
	if(!ga_dSettings[client].IsValid)
	{
		return;
	}
	
	if(!IsPlayerAlive(client))
	{
		return;
	}
	
	Dynamic oRTDSetup = GetArrayCell(g_hRTDs, iRollNo);
	int iRollCodeNum = oRTDSetup.GetInt("rtdcodenum");
	switch(iRollCodeNum)
	{
		case 0:
		{
			int iHealth = GetRandomInt(1, 200);
			SetEntityHealth(client, GetClientHealth(client) + iHealth);
			Format(sServerMsg, iMsgSize, "%T", "RtdRandHealth", client, iHealth);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouRandHealth", client, iHealth);
		}
		case 1:
		{
			int iHealth = GetRandomInt(1, 85);
			SlapPlayer(client, iHealth);
			Format(sServerMsg, iMsgSize, "%T", "RtdSlapHealth", client, iHealth);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouSlapHealth", client, iHealth);
		}
		case 2:
		{
			SetEntPropFloat(client, Prop_Data, "m_flLaggedMovementValue", 2.3);
			Format(sServerMsg, iMsgSize, "%T", "RtdSpeedIncrease", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouSpeedIncrease", client);
		}
		case 3:
		{
			SetEntPropFloat(client, Prop_Data, "m_flLaggedMovementValue", 0.65);
			Format(sServerMsg, iMsgSize, "%T", "RtdSpeedDecrease", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouSpeedDecrease", client);
		}
		case 4:
		{
			ga_dSettings[client].SetBool("vampire", true);	//ga_bVampire[client] = true;
			Format(sServerMsg, iMsgSize, "%T", "RtdVampire", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouVampire", client);
		}
		case 5:
		{
			ga_dSettings[client].SetBool("mirror", true);	//ga_bMirror[client] = true;
			Format(sServerMsg, iMsgSize, "%T", "RtdMirror", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouMirror", client);
		}
		case 6:
		{
			ga_dSettings[client].SetBool("glasses", true);	//ga_bGlasses[client] = true;
			Format(sServerMsg, iMsgSize, "%T", "RtdGlasses", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouGlasses", client);
		}
		case 7:
		{
			if(g_bCSGO)
			{
				ShowOverlay(client, "rtd/tpeye.vmt");
			}
			else
			{
				ShowOverlay(client, "effects/tp_eyefx/tpeye.vmt");	//effects/tp_eyefx/tp_eyefx.vmt
			}
			ga_dSettings[client].SetInt("validation_drugged", ga_dSettings[client].GetInt("clientevent"));	//ga_iDruggedTimer[client] = ga_dSettings[client].GetInt("clientevent");
			ga_dSettings[client].SetBool("has_drugged", true);	//ga_bDruggedTimer[client] = true;
			CreateTimer(1.0, TimerCB_Drugged, GetClientUserId(client), TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
			Format(sServerMsg, iMsgSize, "%T", "RtdDrug", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouDrug", client);
		}
		case 8:
		{
			if(g_bCSGO)
			{
				ShowOverlay(client, "rtd/tp_eyefx.vmt");
			}
			else
			{
				ShowOverlay(client, "effects/tp_eyefx/tp_eyefx.vmt");
			}
			ga_dSettings[client].SetInt("validation_drunk", ga_dSettings[client].GetInt("clientevent"));	//ga_iDrunkTimer[client] = ga_dSettings[client].GetInt("clientevent");
			ga_dSettings[client].SetBool("has_drunk", true);	//ga_bDrunkTimer[client] = true;
			if(!g_bCSGO)
			{
				CreateTimer(1.0, TimerCB_Drunk, GetClientUserId(client), TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
			}
			else
			{
				CreateTimer(0.5, TimerCB_Drunk, GetClientUserId(client), TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
			}
			Format(sServerMsg, iMsgSize, "%T", "RtdDrunk", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouDrunk", client);
		}
		case 9:
		{
			ga_dSettings[client].SetBool("burn", true);	//ga_bBurn[client] = true;
			IgniteEntity(client, 3000.0);
			Format(sServerMsg, iMsgSize, "%T", "RtdBurn", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouBurn", client);
		}
		case 10:
		{
			ga_dSettings[client].SetBool("berserker", true);	//ga_bBerserker[client] = true;
			SetEntityHealth(client, 250);
			SetEntProp(client, Prop_Send, "m_ArmorValue", 200);
			SetEntPropFloat(client, Prop_Data, "m_flLaggedMovementValue", 1.4);
			Format(sServerMsg, iMsgSize, "%T", "RtdBerserker", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouBerserker", client);
		}
		case 11:
		{
			ga_dSettings[client].SetInt("maxjumps", 2);	//ga_iMaxJumps[client] = 2;
			Format(sServerMsg, iMsgSize, "%T", "RtdDoublejump", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouDoublejump", client);
		}
		case 12:
		{
			ga_dSettings[client].SetInt("maxjumps", 3);	//ga_iMaxJumps[client] = 3;
			Format(sServerMsg, iMsgSize, "%T", "RtdTriplejump", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouTriplejump", client);
		}
		case 13:
		{
			SetEntProp(client, Prop_Send, "m_iAccount", 0);
			SetEntProp(client, Prop_Send, "m_ArmorValue", 0);
			SetEntProp(client, Prop_Send, "m_bHasHelmet", 0);
			for(int i = 0; i < 5; i++)	//needs tweaks for additional slots in CSGO?
			{
				int iWeaponEnt = GetPlayerWeaponSlot(client, i);
				if(iWeaponEnt != -1) 
				{
					char sEntClassName[64];
					GetEntityClassname(iWeaponEnt, sEntClassName, sizeof(sEntClassName));
					
					if(!StrEqual(sEntClassName, "weapon_knife")) 
					{
						RemovePlayerItem(client, iWeaponEnt);
					}
				}
			}
			Format(sServerMsg, iMsgSize, "%T", "RtdHomeless", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouHomeless", client);
		}
		case 14:
		{
			ga_dSettings[client].SetInt("validation_slap", ga_dSettings[client].GetInt("clientevent"));	//ga_iSlapTimer[client] = ga_dSettings[client].GetInt("clientevent");
			CreateTimer(5.0, TimerCB_Slap, GetClientUserId(client), TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
			Format(sServerMsg, iMsgSize, "%T", "RtdSlap", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouSlap", client);
		}
		case 15:
		{
			ga_dSettings[client].SetInt("validation_regen", ga_dSettings[client].GetInt("clientevent"));	//ga_iRegenTimer[client] = ga_dSettings[client].GetInt("clientevent");
			CreateTimer(3.0, TimerCB_Regen, GetClientUserId(client), TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
			Format(sServerMsg, iMsgSize, "%T", "RtdRegeneration", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouRegeneration", client);
		}
		case 16:
		{
			SetEntityHealth(client, 50);
			Format(sServerMsg, iMsgSize, "%T", "Rtd50Hp", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYou50Hp", client);
		}
		case 17:
		{
			SetEntityGravity(client, 0.5);
			Format(sServerMsg, iMsgSize, "%T", "RtdHalfGravity", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouHalfGravity", client);
		}
		case 18:
		{
			//SetEntityMoveType(client, MOVETYPE_FLY);
			ga_dSettings[client].SetBool("jetpack", true);	//ga_bJetpack[client] = true;
			Format(sServerMsg, iMsgSize, "%T", "RtdJetpack", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouJetpack", client);
		}
		case 19:
		{
			GivePlayerItem(client, "weapon_flashbang");
			GivePlayerItem(client, "weapon_flashbang");
			Format(sServerMsg, iMsgSize, "%T", "Rtd2Flash", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYou2Flash", client);
		}
		case 20:
		{
			GivePlayerItem(client, "weapon_smokegrenade");
			Format(sServerMsg, iMsgSize, "%T", "Rtd1Smoke", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYou1Smoke", client);
		}
		case 21:
		{
			GivePlayerItem(client, "weapon_flashbang");
			GivePlayerItem(client, "weapon_flashbang");
			GivePlayerItem(client, "weapon_smokegrenade");
			Format(sServerMsg, iMsgSize, "%T", "RtdGrenadeRefill", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouGrenadeRefill", client);
		}
		case 22:
		{
			ga_dSettings[client].SetInt("validation_colors", ga_dSettings[client].GetInt("clientevent"));	//ga_iColourTimer[client] = ga_dSettings[client].GetInt("clientevent");
			CreateTimer(2.0, TimerCB_ChangeColour, GetClientUserId(client), TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
			Format(sServerMsg, iMsgSize, "%T", "RtdColours", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouColours", client);
		}
		case 23:
		{
			ShakeClient(client, 0, 20.0, 5.0, 10000.0);
			EmitSoundToClientAny(client, g_sQuakeSoundPath);
			Format(sServerMsg, iMsgSize, "%T", "RtdShake", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouShake", client);
		}
		case 24:
		{
			ga_dSettings[client].SetBool("reincarnate", true);	//ga_bReincarnate[client] = true;
			ga_dSettings[client].SetInt("clientteam", GetClientTeam(client));	//ga_iTeam[client] = GetClientTeam(client);
			Format(sServerMsg, iMsgSize, "%T", "RtdReincarnate", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouReincarnate", client);
		}
		case 25:
		{
			ga_dSettings[client].SetBool("reincarnate", true);	//ga_bReincarnate[client] = true;
			ga_dSettings[client].SetBool("revive", true);	//ga_bRevive[client] = true;
			ga_dSettings[client].SetInt("clientteam", GetClientTeam(client));	//ga_iTeam[client] = GetClientTeam(client);
			Format(sServerMsg, iMsgSize, "%T", "RtdRevive", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouRevive", client);
		}
		case 26:
		{
			SetEntProp(client, Prop_Send, "m_ArmorValue", 100);
			SetEntProp(client, Prop_Send, "m_bHasHelmet", 1, 1);
			Format(sServerMsg, iMsgSize, "%T", "RtdKevlarHelmet", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouKevlarHelmet", client);
		}
		case 27:
		{
			ga_dSettings[client].SetBool("flamethrower", true);	//ga_bFlamethrower[client] = true;
			Format(sServerMsg, iMsgSize, "%T", "RtdFlamethrower", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouFlamethrower", client);
		}
		case 28:
		{
			ga_dSettings[client].SetBool("acid", true);	//ga_bAcid[client] = true;
			Format(sServerMsg, iMsgSize, "%T", "RtdAcid", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouAcid", client);
		}
		case 29:
		{
			ga_dSettings[client].SetBool("firegrenade", true);	//ga_bFiregrenade[client] = true;
			Format(sServerMsg, iMsgSize, "%T", "RtdFiregrenade", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouFiregrenade", client);
		}
		case 30:
		{
			Format(sServerMsg, iMsgSize, "%T", "RtdNothing", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouNothing", client);
		}
		case 31:
		{
			if(GetClientTeam(client) == 2)
			{
				SetEntityModel(client, "models/player/ct_urban.mdl");
			}
			else
			{
				SetEntityModel(client, "models/player/t_leet.mdl");
			}
			Format(sServerMsg, iMsgSize, "%T", "RtdMole", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouMole", client);
		}
		case 32:
		{
			ga_dSettings[client].SetBool("nofalldmg", true);	//ga_bNofalldamage[client] = true;
			Format(sServerMsg, iMsgSize, "%T", "RtdNoFalldamage", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouNoFalldamage", client);
		}
		case 33:
		{
			ga_dSettings[client].SetBool("jumpboost", true);	//ga_bJumpBoost[client] = true;
			Format(sServerMsg, iMsgSize, "%T", "RtdJumpBoost", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouJumpBoost", client);
		}
		case 34:
		{
			ga_dSettings[client].SetInt("norollsnextrnd", 1);	//ga_iNoRollNextRound[client] = 1;
			Format(sServerMsg, iMsgSize, "%T", "RtdNoRollNextRound", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouNoRollNextRound", client);
		}
		case 35:
		{
			ga_dSettings[client].SetInt("maxrolls", ga_dSettings[client].GetInt("maxrolls") + 3);	//ga_iMaxRolls[client] += 3;
			Format(sServerMsg, iMsgSize, "%T", "RtdThreeMore", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouThreeMore", client);
		}
		case 36:
		{
			ga_dSettings[client].SetInt("validation_rolls", ga_dSettings[client].GetInt("clientevent"));	//ga_iRollTimer[client] = ga_dSettings[client].GetInt("clientevent");
			CreateTimer(60.0, TimerCB_GiveRoll, GetClientUserId(client), TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
			Format(sServerMsg, iMsgSize, "%T", "Rtd2MinRoll", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYou2MinRoll", client);
		}
		case 37:
		{
			ga_dSettings[client].SetInt("validation_flash", ga_dSettings[client].GetInt("clientevent"));	//ga_iFlashBomb[client] = ga_dSettings[client].GetInt("clientevent");
			CreateTimer(10.0, TimerCB_Flash, GetClientUserId(client), TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
			Format(sServerMsg, iMsgSize, "%T", "RtdFlashBomb", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouFlashBomb", client);
		}
		case 38:
		{
			ga_dSettings[client].SetBool("firebomb", true);	//ga_bFirebombed[client] = true;
			ga_dSettings[client].SetInt("validation_timerbeep", 0);	//ga_iTimerbeep[client] = 0;
			CreateTimer(1.0, TimerCB_Timebombbeep, GetClientUserId(client), TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
			int iLen = GetRandomInt(20, 30);
			ga_dSettings[client].SetInt("timebomblen", iLen);	//ga_iTimebomblength[client] = GetRandomInt(20, 30);
			ga_dSettings[client].SetInt("validation_backtimer", iLen - 1);	//ga_iBackTimer[client] = iLen - 1;
			CreateTimer(float(iLen), TimerCB_Firebombslay, GetClientUserId(client), TIMER_FLAG_NO_MAPCHANGE);
			CreateTimer(1.0, TimerCB_ExplosionTimer, GetClientUserId(client), TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
			SetEntityRenderColor(client, 0, 255, 0);
			Format(sServerMsg, iMsgSize, "%T", "RtdFireBomb", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouFireBomb", client);
		}
		case 39:
		{
			int iHealth = GetRandomInt(1, GetClientHealth(client) - 1);
			SetEntityHealth(client, GetClientHealth(client) - iHealth);
			Format(sServerMsg, iMsgSize, "%T", "RtdLostHealth", client, iHealth);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouLostHealth", client, iHealth);
		}
		case 40:
		{
			for(int i = 0; i < 5; i++)	//needs tweaks for additional slots in CSGO?
			{
				int iWeaponEnt = GetPlayerWeaponSlot(client, i);
				if(iWeaponEnt != -1) 
				{
					char sEntClassName[64];
					GetEntityClassname(iWeaponEnt, sEntClassName, sizeof(sEntClassName));
					
					if(!StrEqual(sEntClassName, "weapon_knife")) 
					{
						RemovePlayerItem(client, iWeaponEnt);
					}
				}
			}
			FakeClientCommand(client, "use weapon_knife");
			Format(sServerMsg, iMsgSize, "%T", "RtdLostWeaponsButKnife", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouLostWeaponsButKnife", client);
		}
		case 41:
		{
			ga_dSettings[client].SetBool("modified_fov", true);		//ga_bFOV[client] = true;
			SetEntProp(client, Prop_Send, "m_iFOV", 150);
			SetEntProp(client, Prop_Send, "m_iDefaultFOV", 150);
			ga_dSettings[client].SetBool("tunnelvision", true);	//ga_bTunnelVision[client] = true;
			Format(sServerMsg, iMsgSize, "%T", "RtdTunnelVision", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouTunnelVision", client);
		}
		case 42:
		{
			SetEntityModel(client, "models/props/cs_office/vending_machine.mdl");
			Format(sServerMsg, iMsgSize, "%T", "RtdVendingMachine", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouVendingMachine", client);
		}
		case 43:
		{
			SetEntityModel(client, "models/props/de_tides/vending_turtle.mdl");
			SetEntPropFloat(client, Prop_Data, "m_flLaggedMovementValue", 0.6);
			Format(sServerMsg, iMsgSize, "%T", "RtdTurtle", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouTurtle", client);
		}
		case 44:
		{
			ga_dSettings[client].SetInt("validation_armor", ga_dSettings[client].GetInt("clientevent"));	//ga_iArmorTimer[client] = ga_dSettings[client].GetInt("clientevent");
			CreateTimer(1.0, TimerCB_Armor, GetClientUserId(client), TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
			Format(sServerMsg, iMsgSize, "%T", "RtdArmorRecovery", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouArmorRecovery", client);
		}
		case 45:
		{
			ga_dSettings[client].SetInt("validation_troll", ga_dSettings[client].GetInt("clientevent"));	//ga_iTrollTimer[client] = ga_dSettings[client].GetInt("clientevent");
			CreateTimer(10.0, TimerCB_Troll, GetClientUserId(client), TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
			Format(sServerMsg, iMsgSize, "%T", "RtdTrollOverlay", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouTrollOverlay", client);
		}
		case 46:
		{
			ShowOverlay(client, "debug/yuv.vmt");
			ga_dSettings[client].SetInt("validation_blacknwhite", ga_dSettings[client].GetInt("clientevent"));	//ga_iBnWTimer[client] = ga_dSettings[client].GetInt("clientevent");
			ga_dSettings[client].SetBool("has_bnw", true);	//ga_bBnWTimer[client] = true;
			CreateTimer(1.0, TimerCB_BnW, GetClientUserId(client), TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
			Format(sServerMsg, iMsgSize, "%T", "RtdBlacknWhite", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouBlacknWhite", client);
		}
		case 47:
		{
			ga_dSettings[client].SetBool("goldengun", true);	//ga_bGoldenGun[client] = true;
			Format(sServerMsg, iMsgSize, "%T", "RtdGoldenGun", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouGoldenGun", client);
		}
		case 48:
		{
			ResizePlayer(client, 0.65);
			Format(sServerMsg, iMsgSize, "%T", "RtdMidget", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouMidget", client);
		}
		case 49:
		{
			if(g_bCSGO)
			{
				ShowOverlay(client, "rtd/tp_refract_csgo.vmt");
			}
			else
			{
				ShowOverlay(client, "effects/tp_refract.vmt");
			}
			ga_dSettings[client].SetInt("validation_solar", ga_dSettings[client].GetInt("clientevent"));	//ga_iSolarFlare[client] = ga_dSettings[client].GetInt("clientevent");
			ga_dSettings[client].SetBool("has_solar", true);	//ga_bSolarFlare[client] = true;
			CreateTimer(1.0, TimerCB_SolarFlare, GetClientUserId(client), TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
			Format(sServerMsg, iMsgSize, "%T", "RtdSolarFlare", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouSolarFlare", client);
		}
		case 50:
		{
			ga_dSettings[client].SetBool("hasninja", true);	//ga_bHasNinja[client] = true;
			Format(sServerMsg, iMsgSize, "%T", "RtdNinja", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouNinja", client);
		}
		case 51:
		{
			if(IsValidEntity(client))
			{
				SetEntityRenderMode(client, RENDER_GLOW);
				SetEntityRenderColor(client, 0, 0, 0, 255);
			}
			Format(sServerMsg, iMsgSize, "%T", "RtdBlackGlow", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouBlackGlow", client);
		}
		case 52:
		{
			SetEntityRenderFx(client, RENDERFX_FLICKER_SLOW);
			Format(sServerMsg, iMsgSize, "%T", "RtdFlicker", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouFlicker", client);
		}
		case 53:
		{
			EmitSoundToClientAny(client, g_sRickRollSoundPath);
			//float a_fLoc[3];
			//GetClientAbsOrigin(client, a_fLoc);
			//EmitAmbientSound("rtd/rickrolled.mp3", a_fLoc, client);
			
			//set back to ambient but turn down level (distance)?
			Format(sServerMsg, iMsgSize, "%T", "RtdRickRolled", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouRickRolled", client);
		}
		case 54:
		{
			ga_dSettings[client].SetBool("sprint", true);	//ga_bSprint[client] = true;
			Format(sServerMsg, iMsgSize, "%T", "RtdSprint", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouSprint", client);
		}
		case 55:
		{
			ga_dSettings[client].SetInt("changingmodels", ga_dSettings[client].GetInt("clientevent"));	//ga_iChangingModels[client] = ga_iClientEvent[client];
			CreateTimer(10.0, TimerCB_ChangeModel, GetClientUserId(client), TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
			Format(sServerMsg, iMsgSize, "%T", "RtdChanging", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouChanging", client);
		}
		case 56:
		{
			ga_dSettings[client].SetBool("halfdmg", true);	//ga_bHalfDamage[client] = true;
			Format(sServerMsg, iMsgSize, "%T", "RtdHalfDmg", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouHalfDmg", client);
		}
		case 57:
		{
			ga_dSettings[client].SetBool("dbldmg", true);	//ga_bDblDamage[client] = true;
			Format(sServerMsg, iMsgSize, "%T", "RtdDblDmg", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouDblDmg", client);
		}
		case 58:
		{
			ga_dSettings[client].SetBool("hasghosts", true);	//ga_bHasGhosts[client] = true;
			
			float fTimeDelay = 2.0;
			for(int i = 1; i <= g_cGhostCount.IntValue; i++)
			{
				CreateTimer(fTimeDelay, TimerCallback_Ghost, GetClientUserId(client), TIMER_FLAG_NO_MAPCHANGE);
				fTimeDelay += 0.25;
			}
			Format(sServerMsg, iMsgSize, "%T", "RtdGhost", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouGhost", client);
			PrintToChatAll("%s%s%N has become famous. Crowds begin to gather...", TAG, g_bCSGO? "\x09" : "\x07FF2A00", client);
		}
		 case 59:
		{
			ShowOverlay(client, "rtd/supernovaview.vmt");
			ga_dSettings[client].SetInt("validation_darkness", ga_dSettings[client].GetInt("clientevent"));
			ga_dSettings[client].SetBool("has_darkness", true);
			CreateTimer(1.0, TimerCB_Darkness, GetClientUserId(client), TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
			
			Format(sServerMsg, iMsgSize, "%T", "RtdDarkness", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouDarkness", client);
		}
		case 60:
		{
			ShowOverlay(client, "rtd/nightvision.vmt");
			ga_dSettings[client].SetInt("validation_nv", ga_dSettings[client].GetInt("clientevent"));
			ga_dSettings[client].SetBool("has_nv", true);
			CreateTimer(1.0, TimerCB_NV, GetClientUserId(client), TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
			
			Format(sServerMsg, iMsgSize, "%T", "RtdNightVision", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYouNightVision", client);
		}
		case 61:
		{
			if(g_bZeph)
			{
				Store_SetClientCredits(client, Store_GetClientCredits(client) + g_cGiveCreds.IntValue);
				
				Format(sServerMsg, iMsgSize, "%T", "RtdGiveCreds", client, g_cGiveCreds.IntValue);
				Format(sClientMsg, iClientMsgSize, "%T", "RtdYouGiveCreds", client, g_cGiveCreds.IntValue);
			}
		}
		case 62:
		{
			if(g_bZeph)
			{
				int iNewValue = Store_GetClientCredits(client) - g_cTakeCreds.IntValue;
				if(iNewValue < 0)
				{
					iNewValue = 0;
				}
				Store_SetClientCredits(client, iNewValue);
			
				Format(sServerMsg, iMsgSize, "%T", "RtdTakeCreds", client, g_cTakeCreds.IntValue);
				Format(sClientMsg, iClientMsgSize, "%T", "RtdYouTakeCreds", client, g_cTakeCreds.IntValue);
			}
		}
		/*case 63:
		{
			
			
			Format(sServerMsg, iMsgSize, "%T", "Rtd", client);
			Format(sClientMsg, iClientMsgSize, "%T", "RtdYou", client);
		} */
	}
}

public Action Command_Say(int client, const char[] sCommand, int iArgC)
{
	char sMsg[256];
	GetCmdArgString(sMsg, sizeof(sMsg));
	StripQuotes(sMsg);
	
	if(StrEqual(sMsg, "rtd", false))
	{
		Command_Roll(client, 0);
	}
	if(StrEqual(sMsg, "rtdinfo", false))
	{
		Command_Rtdinfo(client, 0);
	}
	return Plugin_Continue;
}

/////////////////////////////////////////
//////////// MENU HANDLERS //////////////
/////////////////////////////////////////

public int MenuHandler_Rtdinfo(Handle hMenu, MenuAction action, int client, int param2)
{
	if(action == MenuAction_Select)
	{
		char id[11];
		GetMenuItem(hMenu, param2, id, sizeof(id));
		
		char sDescription[256];
		Dynamic oRTDSetup = GetArrayCell(g_hRTDs, StringToInt(id));
		oRTDSetup.GetString("rtddesc", sDescription, sizeof(sDescription));
		PrintToChat(client, "%s%s", TAG, sDescription);
		Command_Rtdinfo(client, 0);
	}
	else if(action == MenuAction_Cancel)
	{
		Menu_RTD(client);
	}
	else if(action == MenuAction_End)
	{
		CloseHandle(hMenu);
	}
}

public int MenuHandler_RtdPopup(Handle hMenu, MenuAction action, int param1, int param2)
{
	if(action == MenuAction_Select)
	{
		char sBuffer[32];
		GetMenuItem(hMenu, param2, sBuffer, sizeof(sBuffer));
		
		if(StrEqual(sBuffer, "autoroll", false))
		{
			GetClientCookie(param1, g_hCookieAutoRoll, sBuffer, sizeof(sBuffer));
			if(StringToInt(sBuffer) == 1)
			{
				SetClientCookie(param1, g_hCookieAutoRoll, "0");
			}
			else
			{
				SetClientCookie(param1, g_hCookieAutoRoll, "1");
			}
		}
		else if(StrEqual(sBuffer, "disable", false))
		{
			SetClientCookie(param1, g_hCookieMenuPopup, "0");
		}
		else if(StrEqual(sBuffer, "yes", false))
		{
			Command_Roll(param1, 0);
		}
		else if(StrEqual(sBuffer, "no", false))
		{
			//do nothing - exit menu
		}
	}
	else if(action == MenuAction_Cancel)
	{
		//
	}
	else if(action == MenuAction_End)
	{
		CloseHandle(hMenu);
	}
}

/////////////////////////////////////////
///////////////// TIMERS ////////////////
/////////////////////////////////////////

public Action TimerCallback_Ghost(Handle Timer, any iUserID)
{
	int client = GetClientOfUserId(iUserID);
	if(IsValidClient(client))
	{
		if(IsPlayerAlive(client))
		{
			AddGhost(client);
		}
	}
}

void AddGhost(int client)
{
	char sMdlPath[PLATFORM_MAX_PATH];
	if(IsValidEntity(client))
	{
		GetEntPropString(client, Prop_Data, "m_ModelName", sMdlPath, sizeof(sMdlPath));
	}
	
	float a_fOrigin[3];
	GetClientEyePosition(client, a_fOrigin);
	
	if(!g_bCSGO)
	{
		int iEntID = CreateEntityByName("hostage_entity");

		DispatchKeyValueVector(iEntID, "Origin", a_fOrigin);
		DispatchSpawn(iEntID); 
		SetEntityModel(iEntID, sMdlPath);
		SetEntProp(iEntID, Prop_Data, "m_takedamage", 0);
		SetEntData(iEntID, g_iCollisionGrpOffs, 2, 4, true);
		SetEntDataEnt2(iEntID, g_iLeaderOffs, client);
		SetEntProp(iEntID, Prop_Send, "m_isRescued", 0);
		if(IsValidEntity(iEntID))
		{
			if(GetEntPropFloat(iEntID, Prop_Send, "m_flModelScale"))
			{
				SetEntPropFloat(iEntID, Prop_Send, "m_flModelScale", GetRandomFloat(0.3, 0.7));
			}
			
			SetEntityRenderMode(iEntID, RENDER_GLOW);
			SetEntityRenderColor(iEntID, GetRandomInt(0, 255), GetRandomInt(0, 255), GetRandomInt(0, 255), 25);
			SetEntProp(iEntID, Prop_Send, "movetype", 3);
			SetEntityGravity(iEntID, 0.1);
		}
		ga_iGhostsOwnersUserID[iEntID] = GetClientUserId(client);
		CreateTimer(4.0, TimerCallback_CheckPos, EntIndexToEntRef(iEntID), TIMER_FLAG_NO_MAPCHANGE|TIMER_REPEAT);
	}
	else
	{
		int iChicken = CreateEntityByName("chicken");
		DispatchKeyValueVector(iChicken, "Origin", a_fOrigin);
		DispatchSpawn(iChicken);
		SetEntDataEnt2(iChicken, g_iLeaderOffs, client);
		SetEntProp(iChicken, Prop_Data, "m_takedamage", 0);
		ga_iGhostsOwnersUserID[iChicken] = GetClientUserId(client);
		CreateTimer(4.0, TimerCallback_CheckPos, EntIndexToEntRef(iChicken), TIMER_FLAG_NO_MAPCHANGE|TIMER_REPEAT);
		//AddGlow(iChicken, 255, 0, 0, 255);	//removed to free up edicts
		SetEntProp(iChicken, Prop_Send, "movetype", 3);
	}
	return;
}

stock void AddGlow(int iEnt, int iR, int iG, int iB, int iA)
{
	SetEntProp(iEnt, Prop_Send, "m_bShouldGlow", true, true);
	SetEntProp(iEnt, Prop_Send, "m_nGlowStyle", 0);
	SetEntPropFloat(iEnt, Prop_Send, "m_flGlowMaxDist", 10000000.0);
	int iOffset = GetEntSendPropOffs(iEnt, "m_clrGlow");
	SetEntData(iEnt, iOffset    , iR, _, true);
	SetEntData(iEnt, iOffset + 1, iG, _, true);
	SetEntData(iEnt, iOffset + 2, iB, _, true);
	SetEntData(iEnt, iOffset + 3, iA, _, true);
}

public Action TimerCallback_CheckPos(Handle Timer, any iEntRef)
{
	int iEntID = EntRefToEntIndex(iEntRef);
	if(iEntID != INVALID_ENT_REFERENCE)
	{
		if(IsValidEntity(iEntID))
		{
			int client = GetClientOfUserId(ga_iGhostsOwnersUserID[iEntID]);
			if(IsValidClient(client))
			{
				if(IsPlayerAlive(client))
				{
					float a_fEntLoc[3], a_fClientLoc[3];	
					GetClientAbsOrigin(client, a_fClientLoc);
					int iOrigin = FindSendPropInfo("CBasePlayer", "m_vecOrigin");
					GetEntDataVector(iEntID, iOrigin, a_fEntLoc);
					
					if((GetVectorDistance(a_fEntLoc, a_fClientLoc, false) > 800) && (ga_bTP_InProgress[iEntID] == false))
					{
						//a_fClientLoc[2] += 5.0;
						Handle data = CreateDataPack();
						WritePackCell(data, EntIndexToEntRef(iEntID));
						WritePackFloat(data, a_fClientLoc[0]);
						WritePackFloat(data, a_fClientLoc[1]);
						WritePackFloat(data, a_fClientLoc[2]);
						ResetPack(data);
						ga_bTP_InProgress[iEntID] = true;
						CreateTimer(1.0, TimerCallback_TeleportEnt, data, TIMER_FLAG_NO_MAPCHANGE);
					}
					return Plugin_Continue;
				}
			}
		}
	}

	if(IsValidEdict(iEntID))
	{
		KillGhost(iEntRef);
	}
	
	return Plugin_Stop;
}

void KillGhost(int iGhostEntRef)
{
	int iGhost = EntRefToEntIndex(iGhostEntRef);
	
	if((iGhost > 0))
	{
		if(IsValidEntity(iGhost))
		{
			if(g_bCSGO)
			{
				float a_fEntLoc[3];	
				int iOrigin = FindSendPropInfo("CBaseEntity", "m_vecOrigin");
				GetEntDataVector(iGhost, iOrigin, a_fEntLoc);
				int iParticle = CreateEntityByName("info_particle_system");
				if(IsValidEntity(iParticle))
				{
					DispatchKeyValue(iParticle, "effect_name", "chicken_gone_feathers");
					DispatchKeyValue(iParticle, "angles", "-90 0 0");
					DispatchKeyValueVector(iParticle, "Origin", a_fEntLoc);
					DispatchSpawn(iParticle);
					ActivateEntity(iParticle);
					AcceptEntityInput(iParticle, "Start");
				}
			}
			AcceptEntityInput(iGhost, "Kill");
		}
		ga_iGhostsOwnersUserID[iGhost] = -1;
	}
}

public Action TimerCallback_TeleportEnt(Handle Timer, any data)
{
	int iEntIDRef = ReadPackCell(data);
	int iEntID = EntRefToEntIndex(iEntIDRef);
	if(IsValidEdict(iEntID))
	{
		float a_fClientLoc[3];
		a_fClientLoc[0] = ReadPackFloat(data);
		a_fClientLoc[1] = ReadPackFloat(data);
		a_fClientLoc[2] = ReadPackFloat(data);
		CloseHandle(data);
		TeleportEntity(iEntID, a_fClientLoc, NULL_VECTOR, NULL_VECTOR);
		SetEntDataEnt2(iEntID, g_iLeaderOffs, GetClientOfUserId(ga_iGhostsOwnersUserID[iEntID]));
		ga_bTP_InProgress[iEntID] = false;
	}
	return Plugin_Continue;
}

public Action TimerCB_ExplosionTimer(Handle hTimer, any iUserID)
{
	int client = GetClientOfUserId(iUserID);
	if(!ga_dSettings[client].IsValid)
	{
		return Plugin_Stop;
	}
	if(IsValidClient(client))
	{
		if(IsPlayerAlive(client) && ga_dSettings[client].GetInt("validation_backtimer") != 0)
		{
			PrintCenterText(client, "%T", "ExplosionIn", client, ga_dSettings[client].GetInt("validation_backtimer"));
			ga_dSettings[client].SetInt("validation_backtimer", ga_dSettings[client].GetInt("validation_backtimer") - 1);	//ga_iBackTimer[client]--;
			return Plugin_Continue;
		}
	}
	return Plugin_Stop;
}
				
public Action TimerCB_Timebombbeep(Handle hTimer, any iUserID)
{
	int client = GetClientOfUserId(iUserID);
	if(!ga_dSettings[client].IsValid)
	{
		return Plugin_Stop;
	}
	if(IsValidClient(client))
	{
		if(IsPlayerAlive(client) && ga_dSettings[client].GetBool("firebomb"))
		{
			ga_dSettings[client].SetInt("validation_timerbeep", ga_dSettings[client].GetInt("validation_timerbeep") + 1);	//ga_iTimerbeep[client]++;
			float a_fLoc[3];
			GetClientAbsOrigin(client, a_fLoc);
			a_fLoc[2] += 10;

			//TE_SetupBeamRingPoint(a_fLoc, (float(ga_dSettings[client].GetInt("timebomblen"))-float(ga_iTimerbeep[client]))*10-1.0), (float(ga_dSettings[client].GetInt("timebomblen"))-float(ga_iTimerbeep[client]))*10, g_iBeamSprite, g_iHaloSprite, 0, 15, 0.5, 5.0, 0.0, view_as<float[3]>({255, 0, 0, 255}), 10, 0);
			TE_Start("BeamRingPoint");
			TE_WriteVector("m_vecCenter", a_fLoc);
			TE_WriteFloat("m_flStartRadius", (view_as<float>((ga_dSettings[client].GetInt("timebomblen")-ga_dSettings[client].GetInt("validation_timerbeep"))*10.0-1.0)));
			TE_WriteFloat("m_flEndRadius", (view_as<float>((ga_dSettings[client].GetInt("timebomblen")-ga_dSettings[client].GetInt("validation_timerbeep"))*10.0)));
			TE_WriteNum("m_nModelIndex", g_iBeamSprite);
			TE_WriteNum("m_nHaloIndex", g_iHaloSprite);
			TE_WriteNum("m_nStartFrame", 0);
			TE_WriteNum("m_nFrameRate", 15);
			TE_WriteFloat("m_fLife", 0.5);
			TE_WriteFloat("m_fWidth", 5.0);
			TE_WriteFloat("m_fEndWidth", 5.0);
			TE_WriteFloat("m_fAmplitude", 0.0);
			TE_WriteNum("r", 255);
			TE_WriteNum("g", 0);
			TE_WriteNum("b", 0);
			TE_WriteNum("a", 255);
			TE_WriteNum("m_nSpeed", 10);
			TE_WriteNum("m_nFlags", 0);
			TE_WriteNum("m_nFadeLength", 0);
			TE_SendToAll();
				
			GetClientEyePosition(client, a_fLoc);
			EmitAmbientSound(SOUND_BLIP, a_fLoc, client, SNDLEVEL_RAIDSIREN);	
			return Plugin_Continue;
		}
	}
	return Plugin_Stop;
}

public Action TimerCB_Firebombslay(Handle hTimer, any iUserID)
{
	int client = GetClientOfUserId(iUserID);
	if(!ga_dSettings[client].IsValid)
	{
		return Plugin_Stop;
	}
	if(IsValidClient(client))
	{
		if(IsPlayerAlive(client) && ga_dSettings[client].GetBool("firebomb"))
		{
			float a_fLoc[3];
			GetClientEyePosition(client, a_fLoc);
			TE_SetupExplosion(a_fLoc, g_iExplosion, 1.0, 4, TE_EXPLFLAG_NONE, 100, 100);
			TE_SendToAll();
			IgniteEntity(client, 15.0);
			
			for(int i = 1; i <= MaxClients; i++)
			{
				if(i == client)
				{
					continue;
				}	
				if(!IsValidClient(i))
				{
					continue;
				}
				if(!IsPlayerAlive(i))
				{
					continue;
				}	
				float a_fLoc2[3];
				GetClientEyePosition(i, a_fLoc2);
				
				float fDist = GetVectorDistance(a_fLoc, a_fLoc2);
				
				if(fDist < 65.0)
				{
					IgniteEntity(i, 10.0);
				}
			}
		}
	}
	ga_dSettings[client].SetBool("firebomb", false);	//ga_bFirebombed[client] = false;
	return Plugin_Stop;
}

public Action TimerCB_Flash(Handle hTimer, any iUserID)
{
	int client = GetClientOfUserId(iUserID);
	if(!ga_dSettings[client].IsValid)
	{
		return Plugin_Stop;
	}
	if(!IsValidClient(client))
	{
		return Plugin_Stop;
	}
	else if(ga_dSettings[client].GetInt("validation_flash") != ga_dSettings[client].GetInt("clientevent"))
	{
		return Plugin_Stop;
	}
	
	FadeClient(client, 1536, 1536, 0x0008, 255, 255, 255, 255);
	
	CreateTimer(0.5, TimerCB_ResetFade, GetClientUserId(client), TIMER_FLAG_NO_MAPCHANGE);
	
	return Plugin_Continue;
}

public Action TimerCB_GiveRoll(Handle hTimer, any iUserID)
{
	int client = GetClientOfUserId(iUserID);
	if(!ga_dSettings[client].IsValid)
	{
		return Plugin_Stop;
	}
	if(!IsValidClient(client))
	{
		return Plugin_Stop;
	}
	else if(ga_dSettings[client].GetInt("validation_rolls") != ga_dSettings[client].GetInt("clientevent"))
	{
		return Plugin_Stop;
	}
	
	ga_dSettings[client].SetInt("maxrolls", ga_dSettings[client].GetInt("maxrolls") + 1);	//ga_iMaxRolls[client]++;
	
	PrintToChat(client, "%sYou have been given another RTD roll!", TAG);
	PrintCenterText(client, "You have been given another RTD roll!");
	
	return Plugin_Continue;
}

public Action TimerCB_ResetSpeed(Handle hTimer, any iUserID)
{
	int client = GetClientOfUserId(iUserID);
	if(!ga_dSettings[client].IsValid)
	{
		return Plugin_Stop;
	}
	if(IsValidClient(client))
	{
		SetEntPropFloat(client, Prop_Data, "m_flLaggedMovementValue", 1.0);
	}
	ga_dSettings[client].SetBool("sprint", false);	//ga_bSprint[client] = false;
	return Plugin_Stop;
}

public Action TimerCB_ResetFade(Handle hTimer, any iUserID)
{
	int client = GetClientOfUserId(iUserID);
	if(IsValidClient(client))
	{
		FadeClient(client, 0, 0, 0x0010, 255, 255, 255, 255);
	}
	return Plugin_Stop;
}

public Action TimerCB_Respawn(Handle hTimer, any iUserID)
{
	int client = GetClientOfUserId(iUserID);
	if(IsValidClient(client))
	{
		CS_RespawnPlayer(client);
	}
	CreateTimer(3.0, TimerCB_Slay, GetClientUserId(client), TIMER_FLAG_NO_MAPCHANGE);
	return Plugin_Stop;
}

public Action TimerCB_Slay(Handle hTimer, any iUserID)
{
	int client = GetClientOfUserId(iUserID);
	if(!ga_dSettings[client].IsValid)
	{
		return Plugin_Stop;
	}
	if(IsValidClient(client))
	{
		if(GetClientTeam(client) != ga_dSettings[client].GetInt("clientteam"))
		{
			ServerCommand("sm_slay #%i", iUserID);
			PrintToChatAll("%s%s%N was slayed for trying to glitch rtd to teamkill!", TAG, g_bCSGO? "\x09" : "\x07FF0000", client);
		}
	}
	return Plugin_Stop;
}
public Action TimerCB_Teleport(Handle hTimer, any iUserID)
{
	int client = GetClientOfUserId(iUserID);
	if(!ga_dSettings[client].IsValid)
	{
		return Plugin_Stop;
	}
	if(IsValidClient(client))
	{
		float a_fOrigin[3];
		ga_dSettings[client].GetVector("deathpos", a_fOrigin);
		TeleportEntity(client, a_fOrigin, NULL_VECTOR, NULL_VECTOR);
	}
	return Plugin_Stop;
}

public Action TimerCB_ChangeColour(Handle hTimer, any iUserID)
{
	int client = GetClientOfUserId(iUserID);
	if(!ga_dSettings[client].IsValid)
	{
		return Plugin_Stop;
	}
	if(!IsValidClient(client))
	{
		return Plugin_Stop;
	}
	else if(ga_dSettings[client].GetInt("validation_colors") != ga_dSettings[client].GetInt("clientevent"))
	{
		return Plugin_Stop;
	}
	
	SetEntityRenderColor(client, GetRandomInt(0, 255), GetRandomInt(0, 255), GetRandomInt(0, 255), 255);
	
	return Plugin_Continue;
}

public Action TimerCB_Slap(Handle hTimer, any iUserID)
{
	int client = GetClientOfUserId(iUserID);
	if(!ga_dSettings[client].IsValid)
	{
		return Plugin_Stop;
	}
	if(!IsValidClient(client))
	{
		return Plugin_Stop;
	}
	else if(ga_dSettings[client].GetInt("validation_slap") != ga_dSettings[client].GetInt("clientevent"))
	{
		return Plugin_Stop;
	}
	
	SlapPlayer(client, 0);
	return Plugin_Continue;
}

public Action TimerCB_Armor(Handle hTimer, any iUserID)
{
	int client = GetClientOfUserId(iUserID);
	if(!ga_dSettings[client].IsValid)
	{
		return Plugin_Stop;
	}
	if(!IsValidClient(client))
	{
		return Plugin_Stop;
	}
	else if(ga_dSettings[client].GetInt("validation_armor") != ga_dSettings[client].GetInt("clientevent"))
	{
		return Plugin_Stop;
	}
	
	if((GetEntProp(client, Prop_Send, "m_ArmorValue") + 2) <= 100)
	{
		SetEntProp(client, Prop_Send, "m_ArmorValue", GetEntProp(client, Prop_Send, "m_ArmorValue") + 2);
	}
	else if((GetEntProp(client, Prop_Send, "m_ArmorValue") + 1) <= 100)
	{
		SetEntProp(client, Prop_Send, "m_ArmorValue", GetEntProp(client, Prop_Send, "m_ArmorValue") + 1);
	}
	
	return Plugin_Continue;
}

public Action TimerCB_Troll(Handle hTimer, any iUserID)
{
	int client = GetClientOfUserId(iUserID);
	if(!ga_dSettings[client].IsValid)
	{
		return Plugin_Stop;
	}
	if(!IsValidClient(client))
	{
		return Plugin_Stop;
	}
	else if(ga_dSettings[client].GetInt("validation_troll") != ga_dSettings[client].GetInt("clientevent"))
	{
		ShowOverlay(client, "");
		return Plugin_Stop;
	}
	
	ShowOverlay(client, "overlays/trollface.vmt");
	CreateTimer(1.0, TimerCB_RemoveOverlay, GetClientUserId(client), TIMER_FLAG_NO_MAPCHANGE);
	
	return Plugin_Continue;
}

public Action TimerCB_Darkness(Handle hTimer, any iUserID)
{
	int client = GetClientOfUserId(iUserID);
	if(!ga_dSettings[client].IsValid)
	{
		return Plugin_Stop;
	}
	if(!IsValidClient(client))
	{
		return Plugin_Stop;
	}
	else if(ga_dSettings[client].GetInt("validation_darkness") != ga_dSettings[client].GetInt("clientevent"))
	{
		ShowOverlay(client, "");
		ga_dSettings[client].SetBool("has_darkness", false);
		return Plugin_Stop;
	}
	
	ShowOverlay(client, "rtd/supernovaview.vmt");
	
	return Plugin_Continue;
}

public Action TimerCB_NV(Handle hTimer, any iUserID)
{
	int client = GetClientOfUserId(iUserID);
	if(!ga_dSettings[client].IsValid)
	{
		return Plugin_Stop;
	}
	if(!IsValidClient(client))
	{
		return Plugin_Stop;
	}
	else if(ga_dSettings[client].GetInt("validation_nv") != ga_dSettings[client].GetInt("clientevent"))
	{
		ShowOverlay(client, "");
		ga_dSettings[client].SetBool("has_nv", false);
		return Plugin_Stop;
	}
	
	ShowOverlay(client, "rtd/nightvision.vmt");
	
	return Plugin_Continue;
}

public Action TimerCB_BnW(Handle hTimer, any iUserID)
{
	int client = GetClientOfUserId(iUserID);
	if(!ga_dSettings[client].IsValid)
	{
		return Plugin_Stop;
	}
	if(!IsValidClient(client))
	{
		ga_dSettings[client].SetBool("has_bnw", false);	//ga_bBnWTimer[client] = false;
		return Plugin_Stop;
	}
	else if(ga_dSettings[client].GetInt("validation_blacknwhite") != ga_dSettings[client].GetInt("clientevent"))
	{
		ShowOverlay(client, "");
		ga_dSettings[client].SetBool("has_bnw", false);	//ga_bBnWTimer[client] = false;
		return Plugin_Stop;
	}
	
	ShowOverlay(client, "debug/yuv.vmt");
	
	return Plugin_Continue;
}

public Action TimerCB_SolarFlare(Handle hTimer, any iUserID)
{
	int client = GetClientOfUserId(iUserID);
	if(!ga_dSettings[client].IsValid)
	{
		return Plugin_Stop;
	}
	if(!IsValidClient(client))
	{
		ga_dSettings[client].SetBool("has_solar", false);	//ga_bSolarFlare[client] = false;
		return Plugin_Stop;
	}
	else if(ga_dSettings[client].GetInt("validation_solar") != ga_dSettings[client].GetInt("clientevent"))
	{
		ShowOverlay(client, "");
		ga_dSettings[client].SetBool("has_solar", false);	//ga_bSolarFlare[client] = false;
		return Plugin_Stop;
	}
	
	if(g_bCSGO)
	{
		ShowOverlay(client, "rtd/tp_refract_csgo.vmt");
	}
	else
	{
		ShowOverlay(client, "effects/tp_refract.vmt");
	}
	
	return Plugin_Continue;
}

public Action TimerCB_ChangeModel(Handle hTimer, any iUserID)
{
	int client = GetClientOfUserId(iUserID);
	if(!ga_dSettings[client].IsValid)
	{
		return Plugin_Stop;
	}
	if(!IsValidClient(client))
	{
		return Plugin_Stop;
	}
	else if(ga_dSettings[client].GetInt("changingmodels") != ga_dSettings[client].GetInt("clientevent"))
	{
		ga_dSettings[client].SetInt("changingmodels", -1);
		return Plugin_Stop;
	}
	
	char sMdl[256], sMsg[256];
	
	if(GetArraySize(g_hValidModels))
	{
		int iModel = GetRandomInt(0, GetArraySize(g_hValidModels) - 1);
		GetArrayString(g_hValidModels, iModel, sMdl, sizeof(sMdl));
		
		Format(sMsg, sizeof(sMsg), "%sYour model has changed to: %s", TAG, sMdl);
		PrintToChat(client, sMsg);
		Format(sMsg, sizeof(sMsg), "%s%N had thier model changed to: %s", TAG, client, sMdl);
		PrintToServer(sMsg);
		LogMessage(sMsg);
		for(int i = 1; i <= MaxClients; i++)
		{
			if(IsValidClient(i))
			{
				PrintToConsole(i, sMsg);
			}
		}
		
		SetEntityModel(client, sMdl);
	}
	else
	{
		Format(sMsg, sizeof(sMsg), "%sNo models loaded to change to...retrying in 3 seconds.", TAG);
		PrintToChat(client, sMsg);
		LoadModels();
		CreateTimer(2.5, TimerCB_ChangeModel, GetClientUserId(client), TIMER_FLAG_NO_MAPCHANGE);
	}
	
	return Plugin_Continue;
}

void UpdatePlayerHitbox(const int client)
{
	static const float a_fGenericPlayerMin[3] = {-16.5, -16.5, 0.0}, a_fGenericPlayerMax[3] = {16.5,  16.5, 73.0};
	float a_fScaledPlayerMin[3], a_fScaledPlayerMax[3];

	a_fScaledPlayerMin = a_fGenericPlayerMin;
	a_fScaledPlayerMax = a_fGenericPlayerMax;

	ScaleVector(a_fScaledPlayerMin, 1.0);
	ScaleVector(a_fScaledPlayerMax, 1.0);
	SetEntPropVector(client, Prop_Send, "m_vecSpecifiedSurroundingMins", a_fScaledPlayerMin);
	SetEntPropVector(client, Prop_Send, "m_vecSpecifiedSurroundingMaxs", a_fScaledPlayerMax);
}

bool ResizePlayer(const int client, float fScale)
{
	SetEntPropFloat(client, Prop_Send, "m_flModelScale", fScale);
	UpdatePlayerHitbox(client);
	return true;
}

public Action TimerCB_RemoveOverlay(Handle hTimer, any iUserID)
{
	int client = GetClientOfUserId(iUserID);
	if(!ga_dSettings[client].IsValid)
	{
		return Plugin_Stop;
	}
	if(IsValidClient(client))
	{
		ShowOverlay(client, "");
		if(ga_dSettings[client].GetInt("validation_troll") == ga_dSettings[client].GetInt("clientevent"))
		{
			return Plugin_Continue;
		}
	}
	return Plugin_Stop;
}

public Action TimerCB_Regen(Handle hTimer, any iUserID)
{
	int client = GetClientOfUserId(iUserID);
	if(!ga_dSettings[client].IsValid)
	{
		return Plugin_Stop;
	}
	if(!IsValidClient(client))
	{
		return Plugin_Stop;
	}
	else if(ga_dSettings[client].GetInt("validation_regen") != ga_dSettings[client].GetInt("clientevent"))
	{
		return Plugin_Stop;
	}
	
	int iHealth = GetClientHealth(client) + 5;
	if(iHealth > 100)
	{
		iHealth = 100;
	}
	
	SetEntityHealth(client, iHealth);
	
	return Plugin_Continue;
}

public Action TimerCB_Drunk(Handle hTimer, any iUserID)
{
	int client = GetClientOfUserId(iUserID);
	if(!ga_dSettings[client].IsValid)
	{
		return Plugin_Stop;
	}
	if(!IsValidClient(client))
	{
		ga_dSettings[client].SetBool("has_drunk", false);	//ga_bDrunkTimer[client] = false;
		return Plugin_Stop;
	}
	else if(ga_dSettings[client].GetInt("validation_drunk") != ga_dSettings[client].GetInt("clientevent"))
	{
		ShowOverlay(client, "");
		ga_dSettings[client].SetBool("has_drunk", false);	//ga_bDrunkTimer[client] = false;
		return Plugin_Stop;
	}
	
	if(g_bCSGO)
	{
		ShowOverlay(client, "rtd/tp_eyefx.vmt");
		/*float a_fAngles[3];
		a_fAngles[0] = GetRandomFloat(-100.0, 100.0);
		a_fAngles[1] = GetRandomFloat(-100.0, 100.0);
		a_fAngles[2] = GetRandomFloat(-100.0, 100.0);
		SetEntPropVector(client, Prop_Send, "m_viewPunchAngle", a_fAngles);*/
	}
	else
	{
		ShowOverlay(client, "effects/tp_eyefx/tp_eyefx.vmt");
		float a_fAngles[3];
		a_fAngles[0] = GetRandomFloat(-15.0, 15.0);
		a_fAngles[1] = GetRandomFloat(-15.0, 15.0);
		a_fAngles[2] = GetRandomFloat(-15.0, 15.0);
		SetEntPropVector(client, Prop_Send, "m_vecPunchAngle", a_fAngles);
	}
	
	return Plugin_Continue;
}

public Action TimerCB_Drugged(Handle hTimer, any iUserID)
{
	int client = GetClientOfUserId(iUserID);
	if(!ga_dSettings[client].IsValid)
	{
		return Plugin_Stop;
	}
	if(!IsValidClient(client))
	{
		ga_dSettings[client].SetBool("has_drugged", false);	//ga_bDruggedTimer[client] = false;
		return Plugin_Stop;
	}
	else if(ga_dSettings[client].GetInt("validation_drugged") != ga_dSettings[client].GetInt("clientevent"))
	{
		ShowOverlay(client, "");
		ga_dSettings[client].SetBool("has_drugged", false);	//ga_bDruggedTimer[client] = false;
		return Plugin_Stop;
	}
	
	if(g_bCSGO)
	{
		ShowOverlay(client, "rtd/tpeye.vmt");
	}
	else
	{
		ShowOverlay(client, "effects/tp_eyefx/tpeye.vmt");	//effects/tp_eyefx/tp_eyefx.vmt
	}
	
	/*if(!g_bCSGO)
	{
		ShowOverlay(client, "effects/tp_eyefx/tpeye.vmt");	//effects/tp_eyefx/tp_eyefx.vmt
	}
	else	//borrowed from funcommands drug due to overlay not functioning properly for csgo
	{
		float a_fAngles[3];
		GetClientEyeAngles(client, a_fAngles);
		
		//a_fAngles[2] = g_DrugAngles[GetRandomInt(0,100) % 20];	//random int mod 20
		a_fAngles[2] = float(GetRandomInt(0,19));
		
		TeleportEntity(client, NULL_VECTOR, a_fAngles, NULL_VECTOR);
		
		int a_iClients[2];
		a_iClients[0] = client;	
		
		int iDuration = 255;
		int iHoldTime = 255;
		int flags = 0x0002;
		int a_iColor[4] = {0, 0, 0, 128};
		a_iColor[0] = GetRandomInt(0,255);
		a_iColor[1] = GetRandomInt(0,255);
		a_iColor[2] = GetRandomInt(0,255);

		UserMsg um_FadeUserMsgId;
		um_FadeUserMsgId = GetUserMessageId("Fade");
		Handle hMsg = StartMessageEx(um_FadeUserMsgId, a_iClients, 1);
		//if(GetUserMessageType() == UM_Protobuf)
		//{
		Protobuf pb = UserMessageToProtobuf(hMsg);
		pb.SetInt("duration", iDuration);
		pb.SetInt("hold_time", iHoldTime);
		pb.SetInt("flags", flags);
		pb.SetColor("clr", a_iColor);
		}
		//else	//shouldnt be needed
		//{
		//	BfWriteShort(hMsg, iDuration);
		//	BfWriteShort(hMsg, iHoldTime);
		//	BfWriteShort(hMsg, flags);
		//	BfWriteByte(hMsg, a_iColor[0]);
		//	BfWriteByte(hMsg, a_iColor[1]);
		//	BfWriteByte(hMsg, a_iColor[2]);
		//	BfWriteByte(hMsg, a_iColor[3]);
		//}
		
		EndMessage();
	}*/
	
	return Plugin_Continue;
}

/////////////////////////////////////////
//////////////// EVENTS /////////////////
/////////////////////////////////////////

public Action Event_Hostage_Follows(Handle hEvent, const char[] sName, bool bDontBroadcast)
{
	if(!g_bDynamicLoaded)
	{
		return Plugin_Continue;
	}
	
	int iEntID = GetEventInt(hEvent, "hostage");
	int client = GetClientOfUserId(ga_iGhostsOwnersUserID[iEntID]);
	if(!IsValidClient(client))
	{
		return Plugin_Continue;
	}
	else if(!IsPlayerAlive(client))
	{
		return Plugin_Continue;
	}
	
	SetEntDataEnt2(iEntID, g_iLeaderOffs, client);

	return Plugin_Changed;
}

public Action Event_PlayerBlind(Handle hEvent, const char[] sName, bool bDontBroadcast)
{
	if(!g_bDynamicLoaded)
	{
		return Plugin_Continue;
	}
	
	int client = GetClientOfUserId(GetEventInt(hEvent,"userid"));
	
	if(!ga_dSettings[client].IsValid)
	{
		return Plugin_Continue;
	}

	if(!ga_dSettings[client].GetBool("glasses"))
	{
		return Plugin_Continue;
	}
	if(IsPlayerAlive(client)) 
	{
		SetEntPropFloat(client, Prop_Send, "m_flFlashMaxAlpha", 0.5);
	}
	
	return Plugin_Continue;
}

public Action Event_WeaponCanUse(int client, int weapon)
{
	if(!g_bDynamicLoaded)
	{
		return Plugin_Continue;
	}
	
	if(!ga_dSettings[client].IsValid)
	{
		return Plugin_Continue;
	}
	
	if(ga_dSettings[client].GetBool("modified_fov"))	//if(ga_bFOV[client])
	{
		SetEntProp(client, Prop_Send, "m_iFOV", 150);
		SetEntProp(client, Prop_Send, "m_iDefaultFOV", 150);
	}
	return Plugin_Continue;
}

public Action Event_OnTakeDamage(int victim, int &attacker, int &inflictor, float &fDamage, int &damagetype, int &weapon, float a_fDmgForce[3], float a_fDmgPosition[3]/*, int damagecustom*/)
{
	if(!g_bDynamicLoaded)
	{
		return Plugin_Continue;
	}
	
	char sClassname[64];
	if(!IsValidClient(victim, true))
	{
		if(ga_dSettings[victim].IsValid)
		{
			if(ga_dSettings[victim].GetBool("burn"))
			{
				if((GetClientHealth(victim) - fDamage) >= 1 && (GetClientHealth(victim) - fDamage) <= 25)
				{
					int iFire = GetEntPropEnt(victim, Prop_Data, "m_hEffectEntity");
					if(IsValidEntity(iFire))
					{
						GetEdictClassname(iFire, sClassname, sizeof(sClassname));
						if(StrEqual(sClassname, "entityflame", false))
						{
							SetEntPropFloat(iFire, Prop_Data, "m_flLifetime", 0.0);
						}
					}
					ga_dSettings[victim].SetBool("burn", false);	//ga_bBurn[victim] = false;
				}
			}
			
			if(ga_dSettings[victim].GetInt("maxjumps") > 1 || ga_dSettings[victim].GetBool("nofalldmg") || ga_dSettings[victim].GetBool("jetpack"))
			{
				if((damagetype & DMG_FALL) && (fDamage < 200))	//added in code so that traps that drop you still kill (only blocks fall dmg if less that 200)
				{
					return Plugin_Handled;
				}
			}
			
			return Plugin_Continue;
		}
	}
	
	if(IsValidClient(victim) && IsValidClient(attacker))
	{
		if(GetClientTeam(victim) == GetClientTeam(attacker))
		{
			return Plugin_Continue;
		}
	}
	
	bool bDmgChanged = false;
	
	if(IsValidClient(attacker))
	{
		if(ga_dSettings[attacker].IsValid)
		{
			if(ga_dSettings[attacker].GetBool("acid"))
			{
				fDamage += 10.0;
				bDmgChanged = true;
			}
			
			if(ga_dSettings[attacker].GetBool("goldengun"))
			{
				fDamage += 2000.0;
				bDmgChanged = true;
			}
			
			if(ga_dSettings[attacker].GetBool("flamethrower"))
			{
				GetEdictClassname(inflictor, sClassname, sizeof(sClassname));
				if(strcmp(sClassname, "weapon_knife") != 0 && strcmp(sClassname, "weapon_hegrenade") != 0)
				{
					if(IsValidClient(victim, true))
					{
						if(IsPlayerAlive(victim))
						{
							IgniteEntity(victim, 2.0);
						}
					}
				}
			}
			
			if(ga_dSettings[attacker].GetBool("firegrenade"))
			{
				GetEdictClassname(inflictor, sClassname, sizeof(sClassname));
				if(strcmp(sClassname, "hegrenade_projectile") == 0)
				{
					IgniteEntity(victim, 2.0);
				}
			}
			
			if(ga_dSettings[attacker].GetBool("berserker"))
			{
				if(0 < inflictor <= MaxClients)
				{ 
					int iWeapon = GetEntPropEnt(attacker, Prop_Send, "m_hActiveWeapon"); 
					if(iWeapon != -1) 
					{ 
						char sWeaponClass[20]; 
						GetEntityClassname(iWeapon, sWeaponClass, sizeof(sWeaponClass)); 
						if(StrContains(sWeaponClass, "knife", false) != -1) 
						{ 
							fDamage = 1000.0;
							bDmgChanged = true;
						}
						else
						{
							fDamage = 0.0;
							bDmgChanged = true;
						}
					} 
				}
			}
			
			if(ga_dSettings[attacker].GetBool("vampire"))
			{
				GetEdictClassname(inflictor, sClassname, sizeof(sClassname));
				if(StrEqual(sClassname, "weapon_knife"))
				{
					SetEntityHealth(attacker, GetClientHealth(attacker)+RoundToNearest(fDamage * 0.75));
					PrintToChat(attacker, "%s%T", TAG, "StoleHp", attacker, RoundToNearest(fDamage * 0.75));
				}
			}
			
			if(ga_dSettings[attacker].GetBool("mirror"))
			{
				if(GetClientHealth(attacker)-RoundToNearest(fDamage * 0.20) <= 0)
				{
					SlapPlayer(attacker, GetClientHealth(attacker)-RoundToNearest(fDamage * 0.20));
				}
				else
				{
					SetEntityHealth(attacker, GetClientHealth(attacker)-RoundToNearest(fDamage * 0.20));
				}
				PrintToChat(attacker, "%s%T", TAG, "LostHp", attacker, RoundToNearest(fDamage * 0.20));
			}
		}
	}
	
	if(IsValidClient(victim))
	{
		if(ga_dSettings[victim].IsValid)
		{
			if(ga_dSettings[victim].GetBool("halfdmg"))
			{
				fDamage = fDamage * 0.5;
				bDmgChanged = true;
			}
			
			if(ga_dSettings[victim].GetBool("dbldmg"))
			{
				fDamage = fDamage * 2;
				bDmgChanged = true;
			}
		}
	}
	
	if(bDmgChanged)
	{
		return Plugin_Changed;
	}
	
	return Plugin_Continue;
}

public Action Event_PlayerSpawn(Handle hEvent, const char[] sName, bool bDontBroadcast)
{
	if(!g_bDynamicLoaded)
	{
		return Plugin_Continue;
	}
	
	int client = GetClientOfUserId(GetEventInt(hEvent, "userid"));
	
	if(!ga_dSettings[client].IsValid)
	{
		return Plugin_Continue;
	}
	
	//ga_dSettings[client].SetInt("clientevent", ga_dSettings[client].GetInt("clientevent") + 1);	//ga_iClientEvent[client]++;
	IncrementValidator(client);
	ResetPlayerData(client);
	
	if(!IsTeamRestricted(client, false))
	{
		if(ga_dSettings[client].GetInt("norollsnextrnd") != 1)	//if not "no roll next round" rtd
		{
			char sBuffer[11];
			GetClientCookie(client, g_hCookieAutoRoll, sBuffer, sizeof(sBuffer));
			//CreateTimer(0.8, TimerCB_GetModel, GetClientUserId(client), TIMER_FLAG_NO_MAPCHANGE);

			if(GetClientTeam(client) >= 2)
			{
				if(strcmp(sBuffer, "1") == 0)
				{
					CreateTimer(1.0, TimerCB_AutoRoll, GetClientUserId(client), TIMER_FLAG_NO_MAPCHANGE);
				}
				else
				{
					GetClientCookie(client, g_hCookieMenuPopup, sBuffer, sizeof(sBuffer));
					if(strcmp(sBuffer, "0") != 0)
					{
						DrawRollMenu(client);
					}
				}
			}
			ga_dSettings[client].SetInt("norollsnextrnd", 0);	//if 0 or 2, set to 0
		}
		else
		{
			ga_dSettings[client].SetInt("norollsnextrnd", 2);	//leave a marker for if they try to use !rtd this round
		}
	}
	
	//KILL GHOSTS
	if(ga_dSettings[client].GetBool("hasghosts"))
	{
		PrintToChatAll("%s%s%N lost popularity and all of their followers left...", TAG, g_bCSGO? "\x09" : "\x07FF2A00", client);
		int iUserID = GetClientUserId(client);
		for(int i = 0; i < 2048; ++i)
		{
			if(ga_iGhostsOwnersUserID[i] == iUserID)
			{
				KillGhost(EntIndexToEntRef(i));
			}
		}
	}
	ga_dSettings[client].SetBool("hasghosts", false);	//ga_bHasGhosts[client] = false;
	
	return Plugin_Continue;
}

void DrawRollMenu(int client)
{
	Menu oMenu = new Menu(MenuHandler_RtdPopup);
	oMenu.SetTitle("%T", "RtdPopupTitle", client);

	//Handle hMenu = CreateMenu(MenuHandler_RtdPopup);
	//SetMenuTitle(hMenu, "%T", "RtdPopupTitle", client);
	
	char sDisplay[64];
	
	Format(sDisplay, sizeof(sDisplay), "%T", "Yes", client);
	oMenu.AddItem("yes", sDisplay);
	Format(sDisplay, sizeof(sDisplay), "%T", "No", client);
	oMenu.AddItem("no", sDisplay);
	GetClientCookie(client, g_hCookieAutoRoll, sDisplay, sizeof(sDisplay));
	if(StringToInt(sDisplay) == 1)
	{
		Format(sDisplay, sizeof(sDisplay), "Disable Auto-roll");
		oMenu.AddItem("autoroll", sDisplay);
	}
	else
	{
		Format(sDisplay, sizeof(sDisplay), "Enable Auto-roll");
		oMenu.AddItem("autoroll", sDisplay);
	}
	Format(sDisplay, sizeof(sDisplay), "%T", "DisablePopup", client);
	oMenu.AddItem("disable", sDisplay);

	//DisplayMenu(hMenu, client, 30);
	oMenu.Display(client, 30);
}

public Action TimerCB_GetModel(Handle hTimer, any iUserID)
{
	int client = GetClientOfUserId(iUserID);
	if(!ga_dSettings[client].IsValid)
	{
		return Plugin_Handled;
	}
	if(IsValidClient(client))
	{
		char sModel[PLATFORM_MAX_PATH];
		GetClientModel(client, sModel, sizeof(sModel));
		ga_dSettings[client].SetString("originalmodel", sModel, sizeof(sModel));
	}
	return Plugin_Handled;
}

public Action TimerCB_AutoRoll(Handle hTimer, any iUserID)
{
	int client = GetClientOfUserId(iUserID);
	if(IsValidClient(client))
	{
		Command_Roll(client, 0);
	}
	return Plugin_Handled;
}

public Action Event_PlayerDeathPre(Handle hEvent, const char[] sName, bool bDontBroadcast)
{
	if(!g_bDynamicLoaded)
	{
		return Plugin_Continue;
	}
	
	int victim = GetClientOfUserId(GetEventInt(hEvent, "userid"));
	if(!ga_dSettings[victim].IsValid)
	{
		return Plugin_Continue;
	}
	if(IsClientInGame(victim))
	{
		/*if(ga_dSettings[victim].GetInt("changingmodels") != -1)
		{
			char sOrigModel[PLATFORM_MAX_PATH], sCurrentModel[PLATFORM_MAX_PATH];
			ga_dSettings[victim].GetString("originalmodel", sOrigModel, sizeof(sOrigModel));
			GetClientModel(victim, sCurrentModel, sizeof(sCurrentModel));
			if(!StrEqual(sOrigModel, sCurrentModel, false))
			{
				//SetEntityModel(victim, sOrigModel);
				//remove model to prevent crashes
				if(GetClientTeam(victim) == 2)
				{
					SetEntityModel(victim, "models/player/ct_urban.mdl");
				}
				else
				{
					SetEntityModel(victim, "models/player/t_leet.mdl");
				}
				RemoveRagdoll(victim);
			}
		}*/
		
		ShowOverlay(victim, "");
	}
	
	//ga_dSettings[victim].SetInt("clientevent", ga_dSettings[victim].GetInt("clientevent") + 1);	//ga_iClientEvent[victim]++;
	IncrementValidator(victim);
	//KILL GHOSTS
	if(ga_dSettings[victim].GetBool("hasghosts"))
	{
		PrintToChatAll("%s%s%N lost his popularity and all of their followers left...", TAG, g_bCSGO? "\x09" : "\x07FF2A00", victim);
		int iUserID = GetClientUserId(victim);
		for(int i = 0; i < 2048; ++i)
		{
			if(ga_iGhostsOwnersUserID[i] == iUserID)
			{
				KillGhost(EntIndexToEntRef(i));
			}
		}
	}
	ga_dSettings[victim].SetBool("hasghosts", false);	//ga_bHasGhosts[victim] = false;
	
	if(ga_dSettings[victim].GetBool("revive"))
	{
		float a_fOrigin[3];
		GetClientAbsOrigin(victim, a_fOrigin);
		ga_dSettings[victim].SetVector("deathpos", a_fOrigin);
	}
	return Plugin_Continue;
}

stock void RemoveRagdoll(int client)
{
	if(IsValidEdict(client))
	{
		int iRagDoll = GetEntDataEnt2(client, g_iRagdollOffs);
		if(iRagDoll != -1)
		{
			AcceptEntityInput(iRagDoll, "Kill");
		}
	}
}

public Action Event_PlayerDeath(Handle hEvent, const char[] sName, bool bDontBroadcast)
{
	if(!g_bDynamicLoaded)
	{
		return Plugin_Continue;
	}
	
	int victim = GetClientOfUserId(GetEventInt(hEvent, "userid"));
	if(!ga_dSettings[victim].IsValid)
	{
		return Plugin_Continue;
	}
	//ga_dSettings[victim].SetInt("clientevent", ga_dSettings[victim].GetInt("clientevent") + 1);	//ga_iClientEvent[victim]++;
	IncrementValidator(victim);
	
	ShowOverlay(victim, "");
	StopSoundsAllChannels(victim);
	
	if(ga_dSettings[victim].GetBool("reincarnate"))
	{
		CreateTimer(0.1, TimerCB_Respawn, GetClientUserId(victim), TIMER_FLAG_NO_MAPCHANGE);
		if(ga_dSettings[victim].GetBool("revive"))
		{
			CreateTimer(0.15, TimerCB_Teleport, GetClientUserId(victim), TIMER_FLAG_NO_MAPCHANGE);
		}
		if(g_cReviveBlockRTDs.BoolValue)
		{
			ga_dSettings[victim].SetInt("norollsnextrnd", 1);
		}
	}
	
	if(ga_dSettings[victim].GetBool("firebomb"))
	{
		float a_fClientLoc[3];
		GetClientEyePosition(victim, a_fClientLoc);
		TE_SetupExplosion(a_fClientLoc, g_iExplosion, 1.0, 4, TE_EXPLFLAG_NONE, 100, 100);
		TE_SendToAll();
		IgniteEntity(victim, 15.0);
		
		for(int i = 1; i <= MaxClients; i++)
		{
			if(i == victim)
			{
				continue;
			}	
			if(!IsValidClient(i))
			{
				continue;
			}
			if(!IsPlayerAlive(i))
			{
				continue;
			}	
			float a_fLoc[3];
			GetClientEyePosition(i, a_fLoc);
			
			float fDist = GetVectorDistance(a_fClientLoc, a_fLoc);
			
			if(fDist < 65.0)
			{
				IgniteEntity(victim, 15.0);
			}
		}
		
		ga_dSettings[victim].SetBool("firebomb", false);	//ga_bFirebombed[victim] = false;
	}
	
	ResetPlayerData(victim);
	
	return Plugin_Continue;
}

public Action Event_RoundStart(Handle hEvent, const char[] sName, bool bDontBroadcast)
{
	if(!g_bDynamicLoaded)
	{
		return Plugin_Continue;
	}
	
	for(int i = 1; i <= MaxClients; ++i)
	{
		if(IsValidClient(i))
		{
			if(ga_dSettings[i].IsValid)
			{
				ga_dSettings[i].SetInt("rolls_used", 0);	//ga_iRollsUsed[i] = 0;
				ShowOverlay(i, "");
				//ga_dSettings[i].SetInt("clientevent", ga_dSettings[i].GetInt("clientevent") + 1);	//ga_iClientEvent[i]++;
				IncrementValidator(i);
			}
		}
	}
	
	return Plugin_Continue;
}

public Action Event_RoundEnd(Handle hEvent, const char[] sName, bool bDontBroadcast)
{
	if(!g_bDynamicLoaded)
	{
		return Plugin_Continue;
	}
	
	for(int i = 1; i <= MaxClients; ++i)
	{
		if(IsValidClient(i))
		{
			if(IsValidClient(i))
			{
				ResetPlayerData(i);
				ShowOverlay(i, "");
				ClientCommand(i, "r_screenoverlay 0");
			}
		}
	}
	
	return Plugin_Continue;
}

/////////////////////////////////////////
////////////// MISC STUFF ///////////////
/////////////////////////////////////////

public void ResetPlayerData(int client)
{
	if(!g_bDynamicLoaded)
	{
		return;
	}
	
	if(!ga_dSettings[client].IsValid)
	{
		return;
	}
	
	ga_dSettings[client].SetInt("rolls_used", 0);					//ga_iRollsUsed[client] = 0;
	ga_dSettings[client].SetInt("maxjumps", 1);					//ga_iMaxJumps[client] = 1;
	ga_dSettings[client].SetInt("timerbeep", 0);					//ga_iTimerbeep[client] = 0;
	ga_dSettings[client].SetInt("maxrolls", 1);					//ga_iMaxRolls[client] = 1;
	//ga_dSettings[client].SetInt("norollsnextrnd", 0);				//ga_iNoRollNextRound[client] = 0;
	ga_dSettings[client].SetInt("changingmodels", -1);			//ga_bChangingModels[client] = -1;
	
	ga_dSettings[client].SetBool("modified_fov", false);			//ga_bFOV[client] = false;
	ga_dSettings[client].SetBool("vampire", false);				//ga_bVampire[client] = false;
	ga_dSettings[client].SetBool("mirror", false);				//ga_bMirror[client] = false;
	ga_dSettings[client].SetBool("glasses", false);				//ga_bGlasses[client] = false;
	ga_dSettings[client].SetBool("burn", false);					//ga_bBurn[client] = false;
	ga_dSettings[client].SetBool("berserker", false);				//ga_bBerserker[client] = false;
	ga_dSettings[client].SetBool("halfdmg", false);				//ga_bHalfDamage[client] = false;
	ga_dSettings[client].SetBool("dbldmg", false);				//ga_bDblDamage[client] = false;
	ga_dSettings[client].SetBool("tunnelvision", false);			//ga_bTunnelVision[client] = false;
	ga_dSettings[client].SetBool("reincarnate", false);			//ga_bReincarnate[client] = false;
	ga_dSettings[client].SetBool("revive", false);				//ga_bRevive[client] = false;
	ga_dSettings[client].SetBool("flamethrower", false);			//ga_bFlamethrower[client] = false;
	ga_dSettings[client].SetBool("acid", false);					//ga_bAcid[client] = false;
	ga_dSettings[client].SetBool("firegrenade", false);			//ga_bFiregrenade[client] = false;
	ga_dSettings[client].SetBool("nofalldmg", false);				//ga_bNofalldamage[client] = false;
	ga_dSettings[client].SetBool("jumpboost", false);				//ga_bJumpBoost[client] = false;
	ga_dSettings[client].SetBool("firebomb", false);				//ga_bFirebombed[client] = false;
	ga_dSettings[client].SetBool("jetpack", false);				//ga_bJetpack[client] = false;
	ga_dSettings[client].SetBool("goldengun", false);				//ga_bGoldenGun[client] = false;
	ga_dSettings[client].SetBool("hasninja", false);				//ga_bHasNinja[client] = false;
	ga_dSettings[client].SetBool("usingninja", false);			//ga_bUsingNinja[client] = false;
	ga_dSettings[client].SetBool("sprint", false);				//ga_bSprint[client] = false;
	ga_dSettings[client].SetBool("activejetpack", false);			//ga_bIsJetpackActive[client] = false;
	
	ga_dSettings[client].SetFloat("fuel", 2.0);					//ga_fFuel[client] = 2.0;
	ga_dSettings[client].SetFloat("fueltime", GetGameTime());		//ga_fTime[client] = GetGameTime();
	ga_dSettings[client].SetFloat("lasthudtime", 2.0);			//ga_fLastHUDTime[client] = 0.0;
	
	char sBuffer[PLATFORM_MAX_PATH];
	Format(sBuffer, sizeof(sBuffer), "");
	ga_dSettings[client].SetString("originalmodel", sBuffer, sizeof(sBuffer));

	ResizePlayer(client, 1.0);
	SetEntProp(client, Prop_Send, "m_iFOV", 90);
	SetEntProp(client, Prop_Send, "m_iDefaultFOV", 90);
	SetEntPropFloat(client, Prop_Data, "m_flLaggedMovementValue", 1.00);
	SetEntityGravity(client, 1.0);
	SetEntityRenderMode(client, RENDER_NORMAL);
	SetEntityRenderColor(client, 255, 255, 255, 255);
	SetEntityRenderFx(client, RENDERFX_NONE);
	
	FadeClient(client, 0, 0, 0x0002, 255, 255, 255, 255);
	ShakeClient(client, 1, 0.0, 1.0, 1.0);
	
	ShowOverlay(client, "");
	ClientCommand(client, "r_screenoverlay 0");
}

void ShakeClient(int client, int iCommand, float fAmplitude, float fFreq, float iDuration)
{
	Handle hShake = StartMessageOne("Shake", client);
	if(GetUserMessageType() == UM_Protobuf) 
	{ 
		PbSetInt(hShake, "command", iCommand);
		PbSetFloat(hShake, "local_amplitude", fAmplitude);
		PbSetFloat(hShake, "frequency", fFreq);
		PbSetFloat(hShake, "duration", iDuration);
	} 
	else 
	{ 
		BfWriteByte(hShake, iCommand);
		BfWriteFloat(hShake, fAmplitude);
		BfWriteFloat(hShake, fFreq);
		BfWriteFloat(hShake, iDuration);
	} 
	EndMessage(); 
}

void FadeClient(int client, int iDuration, int iHoldTime, int iFlags, int iR, int iG, int iB, int iA)
{
	Handle hFadeClient = StartMessageOne("Fade",client); 
	if(GetUserMessageType() == UM_Protobuf) 
	{ 
		int a_iColor[4];
		a_iColor[0] = iR; 
		a_iColor[1] = iG; 
		a_iColor[2] = iB; 
		a_iColor[3] = iA; 
		PbSetInt(hFadeClient, "duration", iDuration); 
		PbSetInt(hFadeClient, "hold_time", iHoldTime); 
		PbSetInt(hFadeClient, "flags", iFlags); //(FFADE_PURGE|FFADE_STAYOUT)
		PbSetColor(hFadeClient, "clr", a_iColor); 
	} 
	else 
	{ 
		BfWriteShort(hFadeClient, iDuration); 
		BfWriteShort(hFadeClient, iHoldTime); 
		BfWriteShort(hFadeClient, iFlags); 
		BfWriteByte(hFadeClient, iR); 
		BfWriteByte(hFadeClient, iG); 
		BfWriteByte(hFadeClient, iB); 
		BfWriteByte(hFadeClient, iA);
	} 
	EndMessage(); 
}

void Client_Push(int client, float a_fEyeAngles[3], float fPower, int a_iVelOverrides[3] = {0,0,0})
{
	float a_fFwdVector[3], a_fNewVel[3];
	
	GetAngleVectors(a_fEyeAngles, a_fFwdVector, NULL_VECTOR, NULL_VECTOR);
	NormalizeVector(a_fFwdVector, a_fFwdVector);
	ScaleVector(a_fFwdVector, fPower);
	
	GetEntPropVector(client, Prop_Data, "m_vecAbsVelocity", a_fNewVel);
	
	for(int i = 0; i < 3; i++)
	{
		switch(a_iVelOverrides[i])
		{
			case 1:
			{
				a_fNewVel[i] = 0.0;
			}
			case 2:
			{				
				if(a_fNewVel[i] < 0.0)
				{
					a_fNewVel[i] = 0.0;
				}
			}
			case 3:
			{				
				if(a_fNewVel[i] < 0.0)
				{
					a_fNewVel[i] *= -1.0;
				}
			}
		}
		
		a_fNewVel[i] += a_fFwdVector[i];
	}
	
	TeleportEntity(client, NULL_VECTOR, NULL_VECTOR, a_fNewVel);
}

void ExecuteJetpack(int client)
{
	float a_fVel[3];
	GetEntPropVector(client, Prop_Data, "m_vecVelocity", a_fVel);

	a_fVel[2] += g_cJetPackVel.FloatValue;
	TeleportEntity(client, NULL_VECTOR, NULL_VECTOR, a_fVel);
}
 
void EnableJetpack(int client)
{
	if(!ga_dSettings[client].IsValid)
	{
		return;
	}
	ga_dSettings[client].SetBool("activejetpack", true);	//ga_bIsJetpackActive[client] = true;
}
 
void DisableJetpack(int client)
{
	if(!ga_dSettings[client].IsValid)
	{
		return;
	}
	ga_dSettings[client].SetBool("activejetpack", false);	//ga_bIsJetpackActive[client] = false;
}

void PrintKeyHintText(int client, const char[] sMsg, any ...)
{
	if(!IsValidClient(client))
	{
		return;
	}
	
	char sFormattedMsg[256];
	VFormat(sFormattedMsg, sizeof(sFormattedMsg), sMsg, 3);

	if(!g_bCSGO)
	{
		Handle hUserMsg = StartMessageOne("KeyHintText", client);
		SetGlobalTransTarget(client);
		BfWriteByte(hUserMsg, 1);
		BfWriteString(hUserMsg, sFormattedMsg);
		EndMessage();
	}
	else
	{
		PrintHintText(client, sFormattedMsg);
	}
	return;
}

/////////////////////////////////////////
////////// CLIENT PREFS MENU ////////////
/////////////////////////////////////////

public void Menu_ClientPrefs(int client, CookieMenuAction action, any info, char[] sBuffer, int iMaxLen)
{
	if(action == CookieMenuAction_SelectOption)
	{
		Menu_RTD(client);
	}
}

int Menu_RTD(int client)
{
	char sBuffer[128];
	Menu oMenu = new Menu(MenuHandler_RTD);
	oMenu.SetTitle("RTD Settings");
	
	oMenu.Pagination = MENU_NO_PAGINATION;
	oMenu.ExitBackButton = true;
	//SetMenuPagination(_hMenu, MENU_NO_PAGINATION);
	//SetMenuExitButton(_hMenu, true);
	
	//autoroll cookie
	char sCookie[11];
	GetClientCookie(client, g_hCookieAutoRoll, sCookie, sizeof(sCookie));
	if(StringToInt(sCookie) == 0)
	{
		Format(sBuffer, sizeof(sBuffer), "Activate Autoroll", client);
	}
	else
	{
		Format(sBuffer, sizeof(sBuffer), "Deactivate Autoroll", client);
	}
	oMenu.AddItem("1", sBuffer, HasFlags(client, g_sAccessFlags)?ITEMDRAW_DEFAULT:ITEMDRAW_DISABLED);
	
	//rtd popup cookie
	GetClientCookie(client, g_hCookieMenuPopup, sCookie, sizeof(sCookie));
	if(StringToInt(sCookie) == 0)
	{
		Format(sBuffer, sizeof(sBuffer), "Activate RTD Popup", client);
	}
	else
	{
		Format(sBuffer, sizeof(sBuffer), "Deactivate RTD Popup", client);
	}
	oMenu.AddItem("2", sBuffer, HasFlags(client, g_sAccessFlags)?ITEMDRAW_DEFAULT:ITEMDRAW_DISABLED);
	
	//rtd info	
	oMenu.AddItem("3", "RTD Info", HasFlags(client, g_sAccessFlags)?ITEMDRAW_DEFAULT:ITEMDRAW_DISABLED);
	
	oMenu.AddItem("4", "Exit");
	
	oMenu.Display(client, MENU_TIME_FOREVER);

	return;
}

public int MenuHandler_RTD(Handle hMenu, MenuAction action, int param1, int param2)
{
	switch(action)
	{
		case MenuAction_End:
		{
			CloseHandle(hMenu);
		}
		case MenuAction_Cancel: 
		{
			if(param2 == MenuCancel_ExitBack)
			{
				ShowCookieMenu(param1);
			}
		}
		case MenuAction_Select:
		{
			char sTemp[8];
			GetMenuItem(hMenu, param2, sTemp, sizeof(sTemp));

			switch(StringToInt(sTemp))
			{
				case 1:
				{
					char cookieAuto[11];
					GetClientCookie(param1, g_hCookieAutoRoll, cookieAuto, sizeof(cookieAuto));
					if(StringToInt(cookieAuto) == 1)
					{
						SetClientCookie(param1, g_hCookieAutoRoll, "0");
						PrintToChat(param1, "%s%T", TAG, "AutorollDisabled", param1);
					}
					else
					{
						SetClientCookie(param1, g_hCookieAutoRoll, "1");
						PrintToChat(param1, "%s%T", TAG, "AutorollActivated", param1);
					}
					
					Menu_RTD(param1);
				}
				case 2:
				{
					char sCookie[11];
					GetClientCookie(param1, g_hCookieMenuPopup, sCookie, sizeof(sCookie));
					if(StringToInt(sCookie) == 1)
					{
						SetClientCookie(param1, g_hCookieMenuPopup, "0");
						PrintToChat(param1, "%sYou have disabled the RTD pop-up.", TAG);
					}
					else
					{
						SetClientCookie(param1, g_hCookieMenuPopup, "1");
						PrintToChat(param1, "%s%T", TAG, "Activated", param1);
					}
					
					Menu_RTD(param1);
				}
				case 3:
				{
					FakeClientCommand(param1, "sm_rtdinfo");
				}
			}
		}
	}
	return;
}

bool IsValidClient(int client, bool bAllowBots = false)
{
	if(!(1 <= client <= MaxClients) || !IsClientInGame(client) || (IsFakeClient(client) && !bAllowBots) || IsClientSourceTV(client) || IsClientReplay(client))
	{
		return false;
	}
	return true;
}

bool HasFlags(int client, char[] sFlags)
{
	if(StrEqual(sFlags, "public", false) || StrEqual(sFlags, "", false))
	{
		return true;
	}
	else if(StrEqual(sFlags, "none", false))	//useful for some plugins
	{
		return false;
	}
	else if(!client)	//if rcon
	{
		return true;
	}
	else if(CheckCommandAccess(client, "sm_not_a_command", ADMFLAG_ROOT, true))
	{
		return true;
	}
	
	AdminId id = GetUserAdmin(client);
	if(id == INVALID_ADMIN_ID)
	{
		return false;
	}
	int flags, clientflags;
	clientflags = GetUserFlagBits(client);
	
	if(StrContains(sFlags, ";", false) != -1) //check if multiple strings
	{
		int i = 0, iStrCount = 0;
		while(sFlags[i] != '\0')
		{
			if(sFlags[i++] == ';')
			{
				iStrCount++;
			}
		}
		iStrCount++; //add one more for stuff after last comma
		
		char[][] a_sTempArray = new char[iStrCount][30];
		ExplodeString(sFlags, ";", a_sTempArray, iStrCount, 30);
		bool bMatching = true;
		
		for(i = 0; i < iStrCount; i++)
		{
			bMatching = true;
			flags = ReadFlagString(a_sTempArray[i]);
			for(int j = 0; j <= 20; j++)
			{
				if(bMatching)	//if still matching, continue loop
				{
					if(flags & (1<<j))
					{
						if(!(clientflags & (1<<j)))
						{
							bMatching = false;
						}
					}
				}
			}
			if(bMatching)
			{
				return true;
			}
		}
		return false;
	}
	else
	{
		flags = ReadFlagString(sFlags);
		for(int i = 0; i <= 20; i++)
		{
			if(flags & (1<<i))
			{
				if(!(clientflags & (1<<i)))
				{
					return false;
				}
			}
		}
		return true;
	}
}

bool IsOnTeam(int client)
{
	if((GetClientTeam(client) == 2) || (GetClientTeam(client) == 3))
	{
		return true;
	}
	
	return false;
}
/*
void StopSoundAllChannels(int client, char[] sSound)
{
	StopSound(client, SNDCHAN_AUTO, sSound);
	StopSound(client, SNDCHAN_WEAPON, sSound);
	StopSound(client, SNDCHAN_VOICE, sSound);
	StopSound(client, SNDCHAN_ITEM, sSound);
	StopSound(client, SNDCHAN_BODY, sSound);
	StopSound(client, SNDCHAN_STREAM, sSound);
	StopSound(client, SNDCHAN_VOICE_BASE, sSound);
	StopSound(client, SNDCHAN_USER_BASE, sSound);
}*/

void StopSoundsAllChannels(int client)
{
	ClientCommand(client, "playgamesound Music.StopAllMusic");
}

void ShowOverlay(int client, char[] sPath)
{
	/*if(g_bCSGO)
	{
		int iFlags2 = GetCommandFlags("r_drawscreenoverlay") & ~FCVAR_CHEAT;
		SetCommandFlags("r_drawscreenoverlay", iFlags2);
		ClientCommand(client, "r_drawscreenoverlay 1");		//FORCE THIS OPTION ON
	}

	int iFlags = GetCommandFlags("r_screenoverlay") & (~FCVAR_CHEAT);
	SetCommandFlags("r_screenoverlay", iFlags);*/
	ClientCommand(client, "r_screenoverlay \"%s\"", sPath);
}

stock void Log(char[] sPath, const char[] sMsg, any ...)	//TOG logging function - path is relative to logs folder.
{
	char sLogFilePath[PLATFORM_MAX_PATH], sFormattedMsg[256];
	BuildPath(Path_SM, sLogFilePath, sizeof(sLogFilePath), "logs/%s", sPath);
	VFormat(sFormattedMsg, sizeof(sFormattedMsg), sMsg, 3);
	LogToFileEx(sLogFilePath, "%s", sFormattedMsg);
}

/*
CHANGELOG:
	3.1.0
		* Changelog started.
		* Redid structure and coding completely.
		* Added root admin cmd to force rtd's.
	4.0.0
		* Rebuilding it for CS:GO compatability.
		* Cleaned up code, etc.
		* Removed <tog> include and added needed code to source.
		* Converted all client variables to use dynamic object for each client.
		* Combined all RTD ADT arrays into one ADT array of dynamic objects.
		* Converted to sourcemod 1.7+ syntax to support dynamic objects code.
		* Added forcing sv_disable_immunity_alpha to 1 (for CS:GO support for ninja rtd).
		* Redid part of the key-values config structure.
		* Switched to "case" logic for RTD, since it is more efficient and it is using integers.
		* Added code in case the client is invalid in ghost check position timer callback to kill ghost. I dont think this code will ever fire, since when the client dies,
		  it kills the ghosts then...but since the check is there, might as well handle what happens if it isnt passed.
		* Added CVar for admin flag to force RTDs (previously it was root only).
		* Updated Force RTD cmd to use either codenumber or codename.
		* Updated flashbang glasses for csgo.
		* Changed a bunch of net props to check for csgo on whether to use bf or pb.
		* Added chickens as a replacement for hostages in csgo for "famous" RTD.
		* Added chicken feathers explosion when they are removed.
		* Combined code sections in plugin to kill ghosts into one section.
		* Added check to disable certain RTDs for CS:GO, and display error in logs if RTD is enabled.
		* Modified overlays to work for CS:GO.
		* Edited stop sound for CS:GO.
		* Combined all client event validation incrementation to use a single function.
		* Added code to change back to default model and remove ragdoll if model has changed.
		* Fixed halo and beam sprites for CS:GO.
		* Used funcommands drug code for now with the drug RTD for CS:GO only.
		* Removed SMLibs include.
	4.0.1:
		* Added clearing dynamic objects on plugin end.
	4.1.0:
		* Edited rtd menu to make the autoroll item a toggle.
		* Removed code to change player model pre-death. Moved nearby line to set client overlay to inside the in game check. Removed TimerCB_GetModel from spawn.
		* Changed g_cAdminFlag from Handle to ConVar.
		* Removed resetting norollsnextrnd on round start. Moved the whole thing to player spawn event.
		* Added cvar for setting if players can use rtd on respawn.
		* Fixed validation_backtimer not being reduced properly. It was reducing clientevent instead....
	4.1.1:
		* Added trtd_teamsallowed cvar and supporting code, per request.
	4.2.0:
		* Moved late load handling to OnConfigsExecuted.
		* Added code to register plugin library.
		* Added access flag cvar for rolls.
		* Added a bunch of checks for if dynamic is loaded, and code to handle dynamic late loading. Spammed functions with checks for dynamic being loaded.
		* Added cvar for ghost count to be spawned for ghost rtd (aka famous).
		* Fixed Jetpack.
		* Edits to ConVar handling to use the class object properties.
		* Added cvar for jetpack fuel amount.
		* Added cvar for jetpack velocity increase.
		* Added cvar for quake rtd sound path.
		* Added cvar for rick roll rtd sound path.
		* Fixed sounds not playing properly for CS:GO.
		* Fixed overlays not working in CS:GO, although the "effects" overlays still do not work (because they dont exist for the game).
		* Changed materials download filename from overlay_downloads.ini to rtd_materials.ini.
		* Added PrintToServer to show what paths are being downloaded and precached.
	4.2.1:
		* Added debug cvar and logging of rolls.
		* Moved vending machine, turtle models, camoflauge, and troll face RTDs to CS:S only.
		* Added a rediculous amount of checking if the client dynamic object is valid.
		* Toned down csgo punch angles for drunk RTD.
		* Added check for player being alive in beginning of AddRollEffect function. It only mattered when using sm_forcertd.
	4.3.0:
		* Added in ability to create per-map override configs. In doing so, moved the configs files to a subfolder and renamed the main one.
		* Found a way to get solar flare working with CS:GO!
		* Found a way to get drunk working with CS:GO with the same overlays as CS:S.
		* Found a way to get drugged working with CS:GO with the same overlays as CS:S.
		* Added missing check in CheckForVisualEffect where client dynamic object could be valid, but it was missing the check for a valid target dynamic object.
		* Added some checks to Event_OnTakeDamage.
	4.3.1:
		* Minor edit to Event_OnTakeDamage to handle case where victim or attacker might not be a valid client. Brought about by the code to verify client isnt suiciding.
	4.3.2
		* Changed health regen from 3 to 5, and cleaned up code with it.
	4.3.3
		* Added 2 zeph store rolls, per request, and associated CVars trtd_givecreds/trtd_takecreds.
		
*/

/*
9:36 PM - XXXXX: does it also
9:36 PM - XXXXX: go by like categories
9:36 PM - That One Guy: so, de_dust2 would be de_dust2.cfg
9:36 PM - XXXXX: for example a server with mg_ (minigames) and dr_ (deathrun) maps on the server
9:36 PM - XXXXX: i can do like mg_.cfg
9:36 PM - XXXXX: and all maps starting with mg_ will get triggered?
9:36 PM - That One Guy: not yet
9:37 PM - That One Guy: i could have it check for an exact match, then loop the files in that folder for a "contains" match
*/

/*
	New RTD Checklist:
		Add to config file
		Add translations
		Code in Rtd (base code, timers/callbacks/, etc)
			If timers, add effects for spectators - function: CheckForVisualEffect
		Add exceptions (games it wont work for) function: RTD_OkToAdd
		If applicable, add to DL tbl, precache, add files to plugin pkg, etc.
			Change relative paths to match rtd directory
	
	Potential RTD ideas: 
	* No recoil. (Be sure to print to chat or console for admins or everyone so that it is clear they arent cheating)
	* Wall hacks (http://www.togcoding.com/showthread.php?t=112254&highlight=esp). (Be sure to print to chat or console for admins or everyone so that it is clear they arent cheating)
	* Look at the following includes: effects, entity_prop_stocks, ata_tools
	* http://www.togcoding.com/showpost.php?p=1718726&postcount=9
	* Anti-camp RTD. Every X seconds, a timer starts (silently) and in another Y seconds, a small explosion goes off at that locations they were at, hurting only them (if theyre still there), perhaps 15 hp ish...test for appropriate radius for explosion
	* Headshots only ; Increased fall dmg ; bullets knock back players ; enemies within X radius take dmg ; Make a fire trail? ; bullets drug other players ; infinite ammo (no reload needed)
	* Reverse movement (https://forums.alliedmods.net/showthread.php?p=2401008). Verify not buggy like in prev testing for this idea.
	
	Potential To Do:
	* Add total rolls left to menu
	* Put tunnel vision on a repeat timer.
	* Move gravity stuff (e.g. half grav) to repeat timer to handle ladders resetting grav. Or perhaps you can just monitor if theyre on a ladder, and set the gravity back after.
	  Would need a check to toggle on if they have a gravity RTD and in OnPlayerRunCmd they're on a ladder, then turn off once theyre not on it and they have been re-set.
	* Create native to give another roll then add to togstore (with disclaimer that it must be used that round): ga_iMaxRolls[client] += 1;
	* Donator = 1 rerolls per map, VIP = 3 - check for reconnect similar to togrejoin and with steam IDs as well and set rerolls = 0 if detected
	* Add cvar for if all RTD rolls should be logged. 0 = disabled. 1 = hlsw. 2 = sm logs (which i think also shows in hlsw).
	* Change CS:GO version of earthquake
	* Fix ninja cloud and active weapon showing for csgo
	
	To Do:
	Change IsValidModel to use a cfg file for bad models
	Move LoadModels inside LoadRTDs - check if changing models RTD is loaded, and only run LoadModels when it does.
	
	
	
	//CS:S overlays
	/overlay @me effects/ar2_altfire1.vmt light show
	/overlay @me effects/combine_binocoverlay.vmt biocular effect
	/overlay @me effects/exit1.vmt eye of sauron
	/overlay @me effects/flicker_128.vmt horror film lighting
	/overlay @me effects/mh_blood1.vmt blood stain
	/overlay @me effects/steadycamfrustum.vmt crazy flashing lights
	/overlay @me effects/strider_bulge_dudv.vmt effect like drunk
	/overlay @me effects/strider_pinch_dudv.vmt effect like drunk
	/overlay @me effects/strider_dark_flare.vmt blind spot in middle of screen
	/overlay @me effects/fog_d1_trainstation_02.vmt fog
	
	csgo overlays:
	effects/puddle.vtf
	dev/dev_prisontvoverlay004
	overlays/shacks_beverage
	overlays/graffiti_3names
	
	custom overlays:
	


	cl_pdump 1 shows client variables in server
	
	"Sprite"
	{
		"$basetexture" "rtd\trollface"
		"$translucent" "1"
		"$spriteorigin" "[ 0.50 1.00 ]"
		"$spriteorientation" "vp_facing_upright"
	}
	"UnlitGeneric"
	{
		"$basetexture" "rtd\somertdeffect"
		"$translucent" 1
		"$decal" 1
		"$decalscale" 1.0
	}
	"Refract"
	{
		"Refract_DX60"
		{
			"$fallbackmaterial" "rtd\nightvision"
		}
		"$REFRACTTINTtexture" "rtd\nightvision"   
	}
	
	Z:\VPKS\HL2\hl2_misc_dir\root\materials\effects
	Z:\VPKS\HL2\hl2_textures_dir\root\materials\effects
	D:\Coding\SM_Scripting\scripting1_8\VPKS\Insurgency\materials\effects
	D:\Coding\SM_Scripting\scripting1_8\VPKS\Insurgency\materials\particle
	D:\Coding\SM_Scripting\scripting1_8\VPKS\Insurgency\materials\particles
	D:\Coding\SM_Scripting\scripting1_8\VPKS\Insurgency\materials\sprites
	
*/